#!/usr/bin/python
########################################################################
#
# File Name:            initDbDom.py
#
# Documentation:        http://docs.4suite.com/DbDom/initDbDom.py.html
#
"""
WWW: http://4suite.com/4DOM         e-mail: support@4suite.com

Copyright (c) 2000 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


import os, sys

from Ft.Ods.StorageManager import Adapters
from Ft.Ods.Tools import _4odb_destroy
from Ft.Ods.Tools import _4odb_create
from Ft.Ods.Parsers.Odl import OdlParse

usage = """initDomDb connString <odlFileLocation>
   connString the string to connect to the database with
   odlFileLocation dom.odl, defaults to directory of this file
   """

def Run(args):

    if len(args) == 2:
        connString = args[1]
        import initDomDb
        odlPath,file = os.path.split(initDomDb.__file__)
    elif len(args) == 3:
        connString = args[1]
        odlPath = args[2]
    else:
        print usage
        sys.exit()

    odlFile = os.path.join(odlPath,'dom.odl')

    if not os.path.exists(odlFile):
        raise "No ODL file at %s" % odlFile

    f = open(odlFile)
    odl = f.read()
    f.close()

    if Adapters.GetDriver().manager.exists(connString):
        _4odb_destroy.Run([1,connString])
    _4odb_create.Run([1,connString])

    OdlParse.parse(1,0,connString,0,'Ft.DbDom',odl)

