########################################################################
#
# File Name:            Uri.py
#
# Documentation:        http://docs.ftsuite.com/4Suite/Uri.py.html
#
"""
WWW: http://4suite.com/4Suite         e-mail: support@4suite.com

Copyright (c) 2000 Fourthought Inc., USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

import string, urlparse, urllib, os
from Ft.Lib import Uuid

class BaseUriResolver:
    def resolve(self, uri, base=''):
        #scheme, netloc, path, params, query, fragment
        scheme = urlparse.urlparse(uri)[0]
        if scheme in ['', 'http', 'ftp', 'file', 'gopher']:
            uri = urllib.basejoin(base, uri)
        if os.access(uri, os.F_OK):
            #Hack because urllib breaks on Windows paths
            stream = open(uri)
        else:
            stream = urllib.urlopen(uri)
        return stream

    def generate(self, hint=None):
        """
        The hint is an object that helps decide what to generate
        Default action is to generate a UUID URN
        """
        return 'urn:uuid:'+Uuid.UuidAsString(Uuid.GenerateUuid())


BASIC_RESOLVER = BaseUriResolver()


import os, urlparse, urllib

def FileNameToUrl(fname):
    urlbase = urlparse.urlunparse(("file", '', os.getcwd()+'/', '', '', ''))
    url = urllib.basejoin(urlbase, fname)
    return url

