########################################################################
#
# File Name: 	       Exception.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Exception.py.html
#
"""
Implements the Exception meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import MetaObject
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.Collections import LiteralCollection
from Ft.Ods import PersistentObject
td = PersistentObject.TupleDefinitions

class Exception(MetaObject.MetaObject):

    def __init__(self,data=None):
        MetaObject.MetaObject.__init__(self,data,MetaKind.MetaKind.mk_exception)

    def form_result(self,target,inverse = 1):
        from Ft.Ods.MetaData import Structure
        self._4ods_formRelationship('result',Structure.Structure,'exception_result','form',target,inverse)

    def drop_result(self,target,inverse = 1):
        self._4ods_dropRelationship('result','exception_result','drop',target,inverse)


    def add_operations(self,target,inverse = 1):
        from Ft.Ods.MetaData import Operation
        self._4ods_addRelationship('operations',Operation.Operation,'exceptions','add',target,inverse)
    form_operations = add_operations


    def remove_operations(self,target,inverse = 1):
        self._4ods_removeRelationship('operations','exceptions','remove',target,inverse)
    drop_operations= remove_operations

    def _4ods_checkRemove(self):
        return 1

    _tupleNames = ('result','operations')

    _tupleDefinitions = {'result':{td.TYPE:Constants.Types.OBJECT,
                                   td.READONLY:1,
                                   td.RELATIONSHIP:1,
                                   },
                         'operations':{td.TYPE:Constants.Types.OBJECT_SET,
                                       td.READONLY:1,
                                       td.RELATIONSHIP:1,
                                       td.COLLECTION_CLASS:LiteralCollection.LiteralSetOfRepositoryObjects,
                                       },
                         }

    _localExtents = ()
