########################################################################
#
# File Name: 	        Literal.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Literal.py.html
#
"""
Implements the Literal meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Operand
from Ft.Ods.MetaData import MetaKind
from Ft.Ods import PersistentObject
td = PersistentObject.TupleDefinitions

from Ft.Ods.StorageManager.Adapters import Constants

import cPickle
import types
try:
    g_stringTypes= [types.StringType, types.UnicodeType]
except:
    g_stringTypes= [types.StringType]


class Literal(Operand.Operand):
    def __init__(self,data=None):
        Operand.Operand.__init__(self,data,MetaKind.MetaKind.mk_literal)
        if data is None:
            self.__dict__['literal_value'] = ''

    def value(self):
        return self.literal_value


    def _4ods_getOdl(self):
        lv = self.literal_value
        if type(lv) == type(1):
            return lv
        elif type(lv) == type(1.2):
            return lv
        elif type(lv) in g_stringTypes:
            if len(lv) == 1:
                return "'" + lv + "'"
            return '"' + lv + '"'
        else:
            raise "Need more input"


    _tupleNames =  ('literal_value',)

    _tupleDefinitions = {'literal_value':{td.TYPE:Constants.Types.ANY,
                                           }
                         }
    _localExtents = ()
