import types

class MetaKindEnumMember:
    def __int__(self): return self._v
    def __str__(self): return self._n

class MetaKindEnum:

    class mk_attribute(MetaKindEnumMember):
        _n = 'mk_boolean'
        _v = 0
    class mk_class(MetaKindEnumMember):
        _n = 'mk_class'
        _v = 1
    class mk_collection(MetaKindEnumMember):
        _n = 'mk_collection'
        _v = 2
    class mk_constant(MetaKindEnumMember):
        _n = 'mk_constant'
        _v = 3
    class mk_const_operand(MetaKindEnumMember):
        _n = 'mk_const_operand'
        _v = 4
    class mk_enumeration(MetaKindEnumMember):
        _n = 'mk_enumeration'
        _v = 5
    class mk_exception(MetaKindEnumMember):
        _n = 'mk_exception'
        _v = 6
    class mk_expression(MetaKindEnumMember):
        _n = 'mk_expression'
        _v = 7
    class mk_interface(MetaKindEnumMember):
        _n = 'mk_interface'
        _v = 8
    class mk_literal(MetaKindEnumMember):
        _n = 'mk_literal'
        _v = 9
    class mk_member(MetaKindEnumMember):
        _n = 'mk_member'
        _v = 10
    class mk_module(MetaKindEnumMember):
        _n = 'mk_module'
        _v = 11
    class mk_operation(MetaKindEnumMember):
        _n = 'mk_operation'
        _v = 12
    class mk_parameter(MetaKindEnumMember):
        _n = 'mk_parameter'
        _v = 13
    class mk_primitive_type(MetaKindEnumMember):
        _n = 'mk_primitive_type'
        _v = 14
    class mk_relationship(MetaKindEnumMember):
        _n = 'mk_relationship'
        _v = 15
    class mk_repository(MetaKindEnumMember):
        _n = 'mk_repository'
        _v = 16
    class mk_structure(MetaKindEnumMember):
        _n = 'mk_strucutre'
        _v = 17
    class mk_type_definition(MetaKindEnumMember):
        _n = 'mk_type_definition'
        _v = 18
    class mk_union(MetaKindEnumMember):
        _n = 'mk_union'
        _v = 19
    class mk_union_case(MetaKindEnumMember):
        _n = 'mk_union_case'
        _v = 20

    def lookup(self, name):
        names = filter(lambda enum, name=name: enum._n == name)
        if names:
            return names[0]
        return ''

    def isMember(self,member):
        return hasattr(member,'__bases__') and member.__bases__[0] == MetaKindEnumMember

    elements = (mk_attribute,
                mk_class,
                mk_collection,
                mk_constant,
                mk_const_operand,
                mk_enumeration,
                mk_exception,
                mk_expression,
                mk_interface,
                mk_literal,
                mk_member,
                mk_module,
                mk_operation,
                mk_parameter,
                mk_primitive_type,
                mk_relationship,
                mk_repository,
                mk_structure,
                mk_type_definition,
                mk_union,
                mk_union_case,
                )

MetaKind = MetaKindEnum()
