########################################################################
#
# File Name: 	       Operation.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Operation.py.html
#
"""
Implements the Operation meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import MetaObject

from Ft.Ods.MetaData import Exception
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.Collections import LiteralCollection
from Ft.Ods import PersistentObject
td = PersistentObject.TupleDefinitions

class Operation(MetaObject.MetaObject):

    def __init__(self,data=None):
        MetaObject.MetaObject.__init__(self,data,MetaKind.MetaKind.mk_operation)



    def add_signature(self,target,inverse = 1):
        from Ft.Ods.MetaData import Parameter
        self._4ods_addRelationship('signature',Parameter.Parameter,'operation','form',target,inverse)
    form_signature = add_signature


    def remove_signature(self,target,inverse = 1):
        self._4ods_removeRelationship('signature','operation','drop',target,inverse)
    drop_signature=remove_signature

    def form_result(self,target,inverse = 1):
        from Ft.Ods.MetaData import Type
        self._4ods_formRelationship('result',Type.Type,'operations','add',target,inverse)
    def drop_result(self,target,inverse = 1):
        self._4ods_dropRelationship('result','operations','remove',target,inverse)

    

    def add_exceptions(self,target,inverse = 1):
        self._4ods_addRelationship('exceptions',Exception.Exception,'operations','add',target,inverse)
    form_exceptions=add_exceptions

    def remove_exceptions(self,target,inverse = 1):
        self._4ods_removeRelationship('exceptions','operations','remove',target,inverse)
    drop_exceptions=remove_exceptions



    def _4ods_checkRemove(self):
        return 1

    _tupleNames = ('signature','result','exceptions')

    _tupleDefinitions = {'signature':{td.TYPE:Constants.Types.OBJECT_LIST,
                                      td.READONLY:1,
                                      td.RELATIONSHIP:1,
                                      td.COLLECTION_CLASS:LiteralCollection.LiteralListOfRepositoryObjects,
                                     },
                         'result':{td.TYPE:Constants.Types.OBJECT,
                                   td.READONLY:1,
                                   td.RELATIONSHIP:1,
                                   },
                         'exceptions':{td.TYPE:Constants.Types.OBJECT_LIST,
                                       td.READONLY:1,
                                       td.RELATIONSHIP:1,
                                       td.COLLECTION_CLASS:LiteralCollection.LiteralListOfRepositoryObjects,
                                       },
                         }

    _localExtents = ()
