########################################################################
#
# File Name:            GenerateMember.py
#
# Documentation:        http://docs.4suite.com/4ODS/GenerateMember.py.html
#
"""
The members of a struct
WWW: http://4suite.com/4ODS        e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods import FtodsParseError
from Ft.Ods.Parsers import GenerateType

#These are used to help generate the stubs
def WriteImports(member, params):
    GenerateType.WriteImports(member.type,params)


#Write the initializers for each member in the class
def WriteInit(member,params):
    GenerateType.WriteInit(member.type,params)

def WriteCommit(member,params):
    GenerateType.WriteCommit(member.type,params)


def WriteRead(member,params):
    GenerateType.WriteRead(member.type,params)

def WriteWrite(member,params):
    GenerateType.WriteWrite(member.type,params)

def WriteDelete(member,params):
    GenerateType.WriteDelete(member.type,params)

#Some functions to create the DB
def SetMetaId(member,db):
    id = db.newMetaId('Member')
    member.metaId = id

def InitDb(member,db):
    db.createMember(member)


