#!/usr/bin/python
########################################################################
#
# File Name:            OdlParserImp.py
#
# Documentation:        http://docs.4suite.com/Ods/Parser/OdlParserImp.py.html
#
"""
An Odl parser for Ft.Ods
WWW: http://4suite.com/ODS        e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

import string

from Ft.Ods.Parsers.Odl import OdlParseTreeMapping
from Ft.Ods.Parsers.Odl import PostProcessor

class OdlParserImp(OdlParseTreeMapping.OdlParseTreeMapping):

    def __init__(self):
        OdlParseTreeMapping.OdlParseTreeMapping.__init__(self)

    def setEbnfProductionNumber(self,num):
        self.prodNum = num

    def parse(self,st):
        rts = OdlParseTreeMapping.OdlParseTreeMapping.parse(self,st)

        #Validate the parse tree
        rt = PostProcessor.PostProcess(rts)

        return rt

    def parseExpression(self,expr):
        return self.parse('~' + expr)


if __name__ == '__main__':

    from Ft.Ods.Parsers.Odl import OdlParserBase
    from Ft.Lib import DumpBgMapping
    from Ft.Ods import Database
    db = Database.Database()
    db.open('test')
    db.new().begin()

    import sys
    p = OdlParserImp()
    if len(sys.argv)==2:
        l = open(sys.argv[1],'r').read()
    else:
        l = raw_input(">>>")
    try:
        p.parse(l)
        print "The ODL"
        print db.schema().resolve("ODLMetaObjects")._4ods_getOdl()
    except OdlParserBase.InternalException, e:
        OdlParserBase.PrintInternalException(e)
    except OdlParserBase.SyntaxException, e:
        OdlParserBase.PrintSyntaxException(e)
