############################################################################
#
# File Name: 		ExtentManager.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/StorageManager/ExtentManager.py/html
#
#Manages Extents
#WWW: http://4suite.com/4ODS         e-mail: support@4suite.com
#
#Copyright (c) 2000 Fourthought Inc, USA.   All Rights Reserved.
#See  http://4suite.com/COPYRIGHT  for license and copyright information

from Ft.Ods.StorageManager import Extent


class ExtentManager:
    def __init__(self,dba):
        self.__dba = dba
        self.__extents = {}
        names = dba.loadExtentNames()
        for name,id_,typ in names:
            self.__extents[name] = Extent.Extent(self,name,id_,typ)


    def _psuedo_del(self):
        for name in self.__extents.keys():
            del self.__extents[name]
        

    def lookup(self,name):
        return self.__extents.get(name,None)


    def getAllBindings(self,object):
        if object is None:
            return self.__extents.keys()
        else:
            res = []
            for k,o in self.__extents.items():
                if object == o:
                    res.append(k)
            return res
            

    def _4ods_getNewObjects(self,name):
        from Ft.Ods import Database
        tx = Database.Database().current()
        return tx._4ods_getNewObjectByExtent(name)

    def _4ods_getDeleteObjects(self,name):
        from Ft.Ods import Database
        tx = Database.Database().current()
        return tx._4ods_getDeleteObjectByExtent(name)


    def _4ods_checkName(self,name):
        if self.__extents.has_key(name):
            raise FtodsBindingException(name)
        return
            
