
from Ft.Ods.StorageManager.Adapters import Constants

import threading, time


def GlobalCache():
    return g_gc



class _GlobalCache:

    def __init__(self):
        self.__objectCache = {}

        self.__objectCache[Constants.ObjectTypes.REPO] = {}
        self.__objectCache[Constants.ObjectTypes.OBJECT] = {}
        self.__objectCache[Constants.ObjectTypes.LITERAL] = {}
        self.__objectCache[Constants.ObjectTypes.COLLECTION] = {}

        self.__lock = threading.RLock()


    def purge(self,testTime):
        self.__lock.acquire()
        try:
            for _type,data in self.__objectCache.items():
                toDelete = filter(lambda x,t=testTime: x[1][0] < t,data.items())
                for t in toDelete:
                    del data[t[0]]
        finally:
            self.__lock.release()
                

    def purgeAll(self):
        self.__lock.acquire()
        try:
            self.__objectCache[Constants.ObjectTypes.REPO] = {}
            self.__objectCache[Constants.ObjectTypes.OBJECT] = {}
            self.__objectCache[Constants.ObjectTypes.LITERAL] = {}
            self.__objectCache[Constants.ObjectTypes.COLLECTION] = {}
        finally:
            self.__lock.release()
        

    def registerObject(self,persistentType,id_,args):
        self.__lock.acquire()
        try:
            self.__objectCache[persistentType][id_] = (time.time(),args)
        finally:
            self.__lock.release()

    def getObject(self,adapter,db,persistentType,id_):
        self.__lock.acquire()
        try:
            if not self.__objectCache[persistentType].has_key(id_):
                return None
            #Up todate check
            if adapter.objectUptoDate(db,persistentType,id_,self.__objectCache[persistentType][id_][0]):
                return self.__objectCache[persistentType][id_][1]
            del self.__objectCache[persistentType][id_]
            return None
        finally:
            self.__lock.release()
        
                             


g_gc = _GlobalCache()

del _GlobalCache
