#!/usr/bin/python
########################################################################
#
# File Name:            initOdsDatabase.py
#
# Documentation:        http://docs.4suite.com/4ODS/initOdsDatabase.py.html
#
"""
WWW: http://4suite.com/4DOM         e-mail: support@4suite.com

Copyright (c) 2000 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""
#"

import os, sys

from Ft.Ods.StorageManager import Adapters
from Ft.Ods.Tools import _4odb_destroy
from Ft.Ods.Tools import _4odb_create
from Ft.Ods.Parsers.Odl import OdlParse

def Init(connString,odlFile,cpp=0):

    if not os.path.exists(odlFile):
        raise "No ODL file at %s" % odlFile

    f = open(odlFile)
    odl = f.read()
    f.close()

    mang = Adapters.GetManager()
    adapt = Adapters.GetAdapter()
    if mang.exists(connString):
        mang.destroy(connString)
    mang.new(connString,adapt)

    genStubs = 0
    initDb = 1

    OdlParse.parse(initDb,cpp,connString,genStubs,'',odl)

