#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_destroy.py
#
# Author:		Mike Olson
#
# Creation Date:	2000-06-10
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_destroy.py.html
#

#A Tool for clearing all data from an existing database.

import sys

def PrintUsage(program):
    import Ft
    print '4ODS version %s' % Ft.__version__
    print
    print 'Completely remove a 4ODS database from the system'
    print
    print 'Usage: %s <database name>' % program
    return

def Run(argv):
    if len(argv) != 2:
        PrintUsage(argv[0])
        sys.exit(1)

    from Ft.Ods.StorageManager import Adapters
    Adapters.GetManager().destroy(argv[1])

if __name__ == '__main__':
    import sys
    Run(sys.argv)
