#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_grant.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_grant.py.html
#


#A Tool for granting access to the database for different users

import sys

def PrintUsage(program):
    import Ft
    print '4ODS version %s' % Ft.__version__
    print
    print 'Change user access in a 4ODS database'
    print
    print 'Usage: %s <database name> level username...' % program
    print
    print 'Access Levels:'
    print '  METADETA  add, modify and delete metadata'
    print '  OBJECT    add, modify and delete objects'
    print '  ALL       add, modify and delete metadata and objects'
    return

def Run(argv):
    if len(argv) < 4:
        PrintUsage(argv[0])
        sys.exit(1)

    import string
    from Ft.Ods.StorageManager import Adapters
    from Ft.Ods.StorageManager.Adapters.Manager import UserAccessLevel

    dbName = argv[1]
    level = getattr(UserAccessLevel, string.upper(argv[2]), None)
    if level is None:
        print 'Invalid access level:', argv[2]
        PrintUsage(argv[0])
        sys.exit(1)
        
    for user in argv[3:]:
        Adapters.GetManager().grant(dbName, user, level)

if __name__ == '__main__':
    Run(sys.argv)
