import os, glob, string
from xml.dom import ext
from xml.dom.ext.reader import Sax2
from xml.dom import implementation
from xml.xslt.Processor import Processor


def GeneratePresentation(index, dest):
    processor = Processor()
    processor.appendStylesheetFile('/usr/local/lib/xslt/presentation.xslt')
    print "Generating in: " + dest
    os.system('install -d %s' % dest)
    doc = Sax2.FromXmlFile(index)
    sources = doc.getElementsByTagNameNS('http://namespaces.fourthought.com/presentation', 'source')
    counter = 0
    for src in sources:
        infile = src.getAttributeNS('', 'fname')
        outfile = src.getAttributeNS('', 'output')
        print infile, " -> ", outfile
        try:
            next = sources[counter + 1].getAttributeNS('', 'output')
        except IndexError:
            next = ''
        try:
            prev = sources[counter - 1].getAttributeNS('', 'output')
        except IndexError:
            prev = ''
        try:
            xml_dom = Sax2.FromXmlFile(infile)
        except IOError:
            print infile, 'not found, moving on...'
            continue
        out_text = processor.runNode(xml_dom, ignorePis=1, topLevelParams={'prev-page': prev, 'next-page': next})
        #print out_text
        counter = counter + 1
        f = open(dest+'/'+outfile, 'w')
        f.write(out_text)
        f.close()
    return

def GenerateIndex(index, dest):
    processor = Processor()
    processor.appendStylesheetFile('/usr/local/lib/xslt/presentation_toc.xslt')
    print "Generating index"
    out_text = processor.runUri(index, ignorePis=1)
    f = open(dest+'/index.html', 'w')
    f.write(out_text)
    f.close()
    

if __name__ == '__main__':
    import sys
    if len(sys.argv) == 3:
        index = sys.argv[1]
        dest = sys.argv[2]
    else:
        print "Present <index_file> <destination_dir>"
        sys.exit(-1)
    GeneratePresentation(index, dest)
    GenerateIndex(index,dest)
