########################################################################
#
# File Name:            XPatternParser.py
#
# Documentation:        http://docs.4suite.com/4XSLT/XPatternParser.py.html
#
"""
Implement the XSLT pattern parsing engine
WWW: http://4suite.com/4XSLT        e-mail: support@4suite.com

Copyright (c) 1999-2000 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from xml.xslt import XPattern
from xml.xpath import XPath
from xml.xpath import ParsedToken
from xml.xpath import XPathParser
from xml.xpath import ParsedPredicateList
from xml.xslt import ParsedStepPattern
from xml.xslt import ParsedRelativePathPattern
from xml.xslt import ParsedLocationPathPattern
from xml.xslt import ParsedPattern
from xml.xslt import XPatternParserBase
from xml.xslt import XsltException
from xml.xslt import Error



p = ParsedToken.ParsedToken('')
def isParsedToken(param):
    return p.isParsedToken(param)

class XPatternParser(XPatternParserBase.XPatternParserBase):
    def __init__(self):
        XPatternParserBase.XPatternParserBase.__init__(self)

    def parsePattern(self,st):
        XPatternParserBase.XPatternParserBase.parse(self,st)
        return self.results
        from xml.xslt import ParsedPattern
        from xml.xslt import ParsedLocationPathPattern

        p = ParsedLocationPathPattern.RootPattern()
        return ParsedPattern.ParsedPattern(p)

    ### Callback methods ###
### These are now implemented in C code ###

    def pattern(self, arg0=None, arg1=None, arg2=None):
        if arg1 == '|':
            l = self.pop()
            p = self.pop()
            p.appendPattern(l)
        else:
            l = self.pop()
            p = ParsedPattern.ParsedPattern(l)
        self.push(p)

    def locationPathPattern(self, arg0=None, arg1=None, arg2=None):
        if arg0 == '/':
            if arg1:
                r = self.pop()
                p = ParsedLocationPathPattern.ParsedLocationPathPattern('/rel',r,None)
                self.push(p)
            else:
                p = ParsedLocationPathPattern.ParsedLocationPathPattern('/',None,None)
                self.push(p)
        elif arg0 == XPath.DOUBLE_SLASH:
            r = self.pop()
            p = ParsedLocationPathPattern.ParsedLocationPathPattern('//rel',r,None)
            self.push(p)
        elif arg1 == '/':
            r = self.pop()
            i = self.pop()
            p = ParsedLocationPathPattern.ParsedLocationPathPattern('id/rel',i,r)
            self.push(p)
        elif arg1 == XPath.DOUBLE_SLASH:
            r = self.pop()
            i = self.pop()
            p = ParsedLocationPathPattern.ParsedLocationPathPattern('id//rel',i,r)
            self.push(p)
        else:
            arg = self.pop()
            if arg.isa('ID_KEY_PATTERN'):
                p = ParsedLocationPathPattern.ParsedLocationPathPattern('id',arg,None)
            else:
                p = ParsedLocationPathPattern.ParsedLocationPathPattern('rel',arg,None)
            self.push(p)

    def idKeyPattern(self, arg0=None, arg1=None, arg2=None, arg3=None, arg4=None, arg5=None):
        if arg3 == ')':
            arg2 == ''
        id = ParsedIdKeyPattern.ParsedIdKeyPattern('id',arg1,arg2)
        self.__push(id)

    def relativePathPattern(self, arg0=None, arg1=None, arg2=None):
        r = self.pop()
        s = None
        if not arg1:
            st = 'step'
        else:
            s = r
            r = self.pop()
            if arg1 == '/':
                st = 'rel/step'
            else:
                st = 'rel//step'
        p = ParsedRelativePathPattern.ParsedRelativePathPattern(st,r,s)
        self.push(p)

    def stepPattern(self, arg0=None, arg1=None, arg2=None):
        if arg2:
            ppl = self.pop()
        else:
            ppl = ParsedPredicateList.ParsedPredicateList([])
        nodeTest = self.pop()
        axis = self.pop()
        self.push(ParsedStepPattern.ParsedStepPattern(axis,nodeTest,ppl))

if __name__ == '__main__':
    st = raw_input(">>> ")
    parser = XPatternParser()
    try:
        result = parser.parsePattern(st)
        result.pprint()
    except XPatternParserBase.InternalException, e:
        XPatternParserBase.PrintInternalException(e)
    except XPatternParserBase.SyntaxException, e:
        XPatternParserBase.PrintSyntaxException(e)
