import cStringIO
from xml.dom import DOMException
from xml.dom import NAMESPACE_ERR
from xml.dom.ext import Print, PrettyPrint
from xml.dom.ext.reader import Sax2

class handler:
    def handleEvent(self,evt):
        print evt.type,'phase =',evt.eventPhase,\
              'target =',evt.target.nodeName,\
              'current target =',evt.currentTarget.nodeName,
        if evt.type=='DOMAttrModified':
            print 'prevValue = ',evt.prevValue,\
                  'newValue = ',evt.newValue,\
                  'attribute name = ',evt.attrName,\
                  'change = ',evt.attrChange
        else:
            print

def register_all_types(target, listener):
    for e in supportedEvents:
        target.addEventListener(e, listener, 0)

def GetExceptionName(code):
    import types
    from xml import dom
    for (name,value) in vars(dom).items():
        if (type(value) == types.IntType and value == code):
            return name

source_1 = """<?xml version = "1.0"?>
<!DOCTYPE ADDRBOOK SYSTEM "addr_book.dtd">
<ADDRBOOK xmlns:xlink="http://www.w3.org/XML/XLink/0.9">
        <ENTRY ID="pa">
                <NAME>Pieter Aaron</NAME>
                <ADDRESS>404 Error Way</ADDRESS>
                <PHONENUM DESC="Work">404-555-1234</PHONENUM>
                <PHONENUM DESC="Fax">404-555-4321</PHONENUM>
                <PHONENUM DESC="Pager">404-555-5555</PHONENUM>
                <EMAIL>pieter.aaron@inter.net</EMAIL>
        </ENTRY>
        <ENTRY-LINK xlink:link="simple" xlink:href="addr_book2.xml"/>
        <ENTRY ID="en">
                <NAME>Emeka Ndubuisi</NAME>
                <ADDRESS>42 Spam Blvd</ADDRESS>
                <PHONENUM DESC="Work">767-555-7676</PHONENUM>
                <PHONENUM DESC="Fax">767-555-7642</PHONENUM>
                <PHONENUM DESC="Pager">800-SKY-PAGEx767676</PHONENUM>
                <EMAIL>endubuisi@spamtron.com</EMAIL>
        </ENTRY>
        <ENTRY ID="vz">
                <NAME>Vasia Zhugenev</NAME>
                <ADDRESS>2000 Disaster Plaza</ADDRESS>
                <PHONENUM DESC="Work">000-987-6543</PHONENUM>
                <PHONENUM DESC="Cell">000-000-0000</PHONENUM>
                <EMAIL>vxz@magog.ru</EMAIL>
        </ENTRY>
</ADDRBOOK>"""
        
expected_1 = """<doc><elt xmlns:spam='http://logilab' spam:att='value1'/></doc>"""

        
def Test(tester):

    tester.startGroup("Alexander Fayolle Demonstrates Events, which he Finished up")

    tester.startTest('Basic event task')
    from xml.dom.ext.reader import Sax2
    from xml.dom.Event import supportedEvents

    h=handler()

    d=Sax2.FromXml('<doc/>')
    register_all_types(d,h)
    register_all_types(d.documentElement,h)
    n = d.createElement('toto')
    register_all_types(n,h)
    d.documentElement.appendChild(n)
    d.documentElement.setAttributeNS('','foo','bar')
    a = d.documentElement.getAttributeNodeNS('','foo')
    a.value = 'baz'

    tester.testDone()

    return tester.groupDone()


if __name__ == '__main__':
    import sys
    import TestSuite

    tester = TestSuite.TestSuite()
    retVal = Test(tester)
    sys.exit(retVal)


'''
Alexander's message:

Subject: 
        [4suite] DOM L2 events implementation
   Date: 
        Mon, 6 Nov 2000 16:39:15 +0100 (CET)
   From: 
        Alexandre Fayolle <Alexandre.Fayolle@logilab.fr>
    To: 
        4Suite mailing list <4suite@dollar.fourthought.com>




Hello there,

As promised, here is a patch for 4DOM (latest cvs snapshot) to implement
DOM L2 events. I packed in the setAttribute/setAttributeNS bug fix,
because I'm a nice guy.

I found the DOM event spec quite ambiguous on some points, so I had to
make assumptions, especially for the DOMAttrModified events (I set
prevValue to None when creating a new attribute, and newValue to None when
removing it). there are two things I did not implement:

 * readonly attributes in Event and MutationEvent
 * generation of DOMNodeRemovedFromDocument and
DOMNodeInsertedIntoDocument events, because I could not figure when to
generate them.

Maybe there are still bugs in this implementation, but at least it does
not seem to break Narval, so I'd say that if you don't use events in your
code, applying the patch should not break anything ;o)

Here is a small python script which demonstrates the use of DOM events:

'''
