import cStringIO
from xml.dom import DOMException
from xml.dom import NAMESPACE_ERR
from xml.dom.ext import Print, PrettyPrint
from xml.dom.ext.reader import Sax2


def GetExceptionName(code):
    import types
    from xml import dom
    for (name,value) in vars(dom).items():
        if (type(value) == types.IntType and value == code):
            return name


expected_1 = """<HTML>
<HEAD></HEAD>
<BODY><B>&Egrave; BUG</B></BODY>
</HTML>"""


def Test(tester):

    tester.startGroup("Enrico Scoda <scoda@alias.it>'s Printer Problems")

    tester.startTest('Building doc')
    
    from xml.dom import implementation
    doc = implementation.createHTMLDocument('BUG')
    doc.createElement('BODY')
    t = doc.createTextNode('\303\211TEXT')
    doc.body.appendChild(t)
    
    stream = cStringIO.StringIO()
    Print(doc, stream=stream)
    result = stream.getvalue()
    if result != expected_1:
        tester.error('Expected\n"""%s"""\ngot\n"""%s"""'%(repr(expected_1), repr(result)))

    tester.testDone()

    return tester.groupDone()


if __name__ == '__main__':
    import sys
    import TestSuite

    tester = TestSuite.TestSuite()
    retVal = Test(tester)
    sys.exit(retVal)
