import cStringIO
from xml.dom import DOMException
from xml.dom import NAMESPACE_ERR
from xml.dom.ext import Print, PrettyPrint
from xml.dom.ext.reader import Sax2


def GetExceptionName(code):
    import types
    from xml import dom
    for (name,value) in vars(dom).items():
        if (type(value) == types.IntType and value == code):
            return name


source_1 = "<foo a1='1' a2='2' a3='3'/>"


expected_1 = "\n<foo a1='1' a2='2' a3='3'/>\n"


def Test(tester):

    tester.startGroup("Michael Dyck <MichaelDyck@home.com>'s ImportNode Problems")

    tester.startTest('test 1')

    from xml.dom import Document
    from xml.dom.ext.reader import PyExpat
    from xml.dom.ext import PrettyPrint

    reader = PyExpat.Reader()
    doc1 = reader.fromString(source_1)
    original_node = doc1.documentElement
    PrettyPrint( original_node )

    doc2 = Document.Document( None )
    imported_node = doc2.importNode( original_node, deep=1 )
    
    stream = cStringIO.StringIO()
    PrettyPrint(imported_node, stream=stream)
    
    result = stream.getvalue()
    if result != expected_1:
        tester.error('Expected\n"""%s"""\ngot\n"""%s"""'%(repr(expected_1), repr(result)))

    tester.testDone()

    return tester.groupDone()


if __name__ == '__main__':
    import sys
    import TestSuite

    tester = TestSuite.TestSuite()
    retVal = Test(tester)
    sys.exit(retVal)
