
import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

from Ft.Ods.Collections import CollectionOfValues
from Ft.Ods.Collections import CollectionOfPersistentObjects
from Ft.Ods.Collections import LiteralCollection
from Ft.Ods.Collections import ListBase
from Ft.Ods.Collections import SetBase
from Ft.Ods.Collections import BagBase
from Ft.Ods import Database
from Ft.Ods.StorageManager.Adapters import Constants

from Ft.Ods.MetaData import Module


def test_literal_collection(tester,klass):
    #Nothing to test
    return 1


def test_list_base(tester,klass,fac):

    lb = klass()
    lb2 = lb.copy()

    values = []
    for ctr in range(6):
        values.append(fac.next())

    tester.startTest("Test insert_first")
    lb.insert_element_first(values[0])
    tester.testResults(1,len(lb),done=0,msg='insert first')
    tester.testResults(values[0],lb[0],done=0,msg='insert first2')
    lb.insert_element_first(values[1])
    tester.testResults(2,len(lb),done=0,msg='insert first3')
    tester.testResults(values[1],lb[0],done=0,msg='insert first4')
    tester.testDone()


    tester.startTest("Test insert_element_last")
    lb.insert_element_last(values[2])
    tester.testResults(3,len(lb),done=0,msg='insert last')
    tester.testResults(values[2],lb[-1],done=0,msg='insert last2')
    tester.testDone()


    tester.startTest("Test insert_element_after")
    lb.insert_element_after(values[3],1)
    tester.testResults(4,len(lb),done=0,msg='insert after')
    tester.testResults(values[3],lb[2],done=0,msg='insert after2')
    tester.testDone()


    tester.startTest("test insert_element_before")
    lb.insert_element_before(values[4],1)
    tester.testResults(5,len(lb),done=0,msg='insert before')
    tester.testResults(values[4],lb[1],done=0,msg='insert before2')
    tester.testDone()


    tester.startTest("Test insert exceptions")


    from Ft.Ods.Collections.ListBase import ListBase

    try:
        lb.insert_element_after(values[5],-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised1")


    try:
        lb.insert_element_after(values[5],10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised2")
    
    try:
        lb.insert_element_before(values[5],-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised3")
    
    try:
        lb.insert_element_before(values[5],10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised4")
    



    tester.startTest("Test Retrieve_element_at")

    tester.testResults(values[4],lb.retrieve_element_at(1),done=0,msg='retrieve_at1')
    try:
        lb.retrieve_element_at(-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised")
    
    try:
        lb.retrieve_element_at(10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised")
    
    tester.testDone()


    tester.startTest("TEst retrieve element first")
    tester.testResults(values[1],lb.retrieve_first_element(),done=0,msg='first1')
    tester.testDone()

    tester.startTest("test retrieve element last")
    tester.testResults(values[2],lb.retrieve_last_element(),done=0,msg='last1')
    tester.testDone()


    tester.startTest("Test replace element")
    lb.replace_element_at(values[5],1)
    tester.testResults(5,len(lb),done=0,msg='replace element')
    tester.testResults(values[5],lb[1],done=0,msg='replace 1')
    try:
        lb.replace_element_at(values[1],-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        test.error("Proper exception not raised")
    
    try:
        lb.replace_element_at(values[1],10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        test.error("Proper exception not raised")

    tester.testDone()

    tester.startTest("Test remove_element_at")
    lb.remove_element_at(1)
    tester.testResults(4,len(lb),done=0,msg='remove element')
    tester.testResults(values[0],lb[1],done=0,msg='remove 1')
    try:
        lb.remove_element_at(-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised")
    
    try:
        lb.remove_element_at(10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        tester.error("Proper exception not raised")

    tester.testDone()



    tester.startTest("remove_first_element")
    lb.remove_first_element()
    tester.testResults(3,len(lb),done=0,msg='remove first element')
    tester.testResults(values[0],lb[0],done=0,msg='remove first 1')
    tester.testDone()


    tester.startTest("Test remove last element")
    lb.remove_last_element()
    tester.testResults(2,len(lb),done=0,msg='remove last element')
    tester.testResults(values[3],lb[-1],done=0,msg='remove last 1')
    tester.testDone()


    del lb[:]

    tester.startTest("Test first and last exceptions")

    from Ft.Ods.Collections import CollectionBase

    try:
        lb.remove_first_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        tester.error("Proper exception not thrown")

    try:
        lb.remove_last_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        tester.error("Proper exception not thrown")
    try:
        lb.retrieve_first_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        tester.error("Proper exception not thrown")

    try:
        lb.retrieve_last_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        tester.error("Proper exception not thrown")

    tester.testDone()



    lb2 = lb.copy()

    lb.insert_element(values[0])
    lb2.insert_element(values[1])

    tester.startTest("Test concat")
    rt = lb.concat(lb2)
    tester.testResults(2,len(rt),done=0,msg='concat')
    tester.testResults(1,values[0]in rt,done=0,msg='concat 1')
    tester.testResults(1,values[1]in rt,done=0,msg='concat 1')
    tester.testDone()



    tester.startTest("test append")
    lb.append(lb2)
    tester.testResults(2,len(rt),done=0,msg='append')
    tester.testResults(1,values[0]in rt,done=0,msg='append 1')
    tester.testResults(1,values[1]in rt,done=0,msg='append 1')
    tester.testDone()

    tester.startTest("Test is Ordered")
    tester.testResults(1,lb.is_ordered(),done=0,msg='ordered')
    tester.testDone()

    tester.startTest("Test is Allows Duplicates")
    tester.testResults(1,lb.allows_duplicates(),done=0,msg='duplicates')
    tester.testDone()


    tester.startTest("Test insert element override")
    del lb[:]
    lb.insert_element(values[0])
    lb.insert_element(values[1])
    tester.testResults(values[1],lb.retrieve_last_element(),done=0,msg='insert10')
    tester.testDone()

    tester.startTest("Test remove element override")
    lb.remove_element(values[0])
    tester.testResults(1,len(lb),done=0,msg='remove 10')
    tester.testResults(values[1],lb[0],done=0,msg='remove 11')
    tester.testDone()
    
    


def test_set_base(tester,klass,fac):

    sb = klass()
    sb2 = sb.copy()

    values = []
    for ctr in range(3):
        values.append(fac.next())

    sb.insert_element(values[0])
    sb.insert_element(values[1])

    sb2.insert_element(values[1])
    sb2.insert_element(values[2])

    tester.startTest("Test Union")
    rt = sb.create_union(sb2)
    tester.testResults(1,len(rt),done=0,msg='union 1')
    tester.testResults(values[1],rt[0],done=0,msg='union 2')
    tester.testDone()


    tester.startTest("Test Intersection")
    rt = sb.create_intersection(sb2)
    tester.testResults(3,len(rt),done=0,msg='int 1')
    tester.testResults(1,values[0] in rt,done=0,msg='int 2')
    tester.testResults(1,values[1] in rt,done=0,msg='int 3')
    tester.testResults(1,values[2] in rt,done=0,msg='int 4')
    tester.testDone()

    tester.startTest("Difference Works")
    rt = sb.create_difference(sb2)
    tester.testResults(2,len(rt),done=0,msg='diff 1')
    tester.testResults(1,values[0] in rt,done=0,msg='diff 2')
    tester.testResults(1,values[2] in rt,done=0,msg='diff 4')
    tester.testDone()
    tester.testDone()

    tester.startTest("Test Subset")
    union = sb.create_union(sb2)
    inter = sb.create_intersection(sb2)
    diff = sb.create_difference(sb2)
    tester.testResults(0,sb.is_subset_of(union),done=0,msg='subset')
    tester.testResults(1,sb.is_subset_of(inter),done=0,msg='subset2')
    tester.testDone()

    tester.startTest("Test Proper subset")
    tester.testResults(0,sb.is_proper_subset_of(sb),done=0,msg='p subset')
    tester.testResults(1,sb.is_proper_subset_of(inter),done=0,msg='p subset2')
    tester.testDone()


    tester.startTest("Test Superset")
    tester.testResults(1,inter.is_superset_of(sb),done=0,msg='superset')
    tester.testResults(0,union.is_superset_of(sb),done=0,msg='superset2')
    tester.testDone()

    tester.startTest("Test proper superset")    
    tester.testResults(0,sb.is_proper_superset_of(sb),done=0,msg='p superset')
    tester.testResults(1,inter.is_proper_superset_of(sb),done=0,msg='superset2')
    tester.testDone()


    tester.startTest("Test is Ordered")
    tester.testResults(0,sb.is_ordered(),done=0,msg='ordered')
    tester.testDone()

    tester.startTest("Test Allows Duplicates")
    tester.testResults(0,sb.allows_duplicates(),done=0,msg='duplicates')
    tester.testDone()


    tester.startTest("Test insert element override")

    del sb[:]
    sb.insert_element(values[0])
    sb.insert_element(values[0])
    tester.testResults(1,len(sb),done=0,msg='insert 1000')
    tester.testDone()


def test_bag_base(tester,klass,fac):

    bb=klass()

    values = []
    for ctr in range(3):
        values.append(fac.next())


    tester.startTest("Test Occurrences_of")
    tester.testResults(0,bb.occurrences_of(values[0]),done=0,msg='occ1')
    bb.insert_element(values[0])
    tester.testResults(1,bb.occurrences_of(values[0]),done=0,msg='occ2')
    bb.insert_element(values[0])
    tester.testResults(2,bb.occurrences_of(values[0]),done=0,msg='occ3')
    tester.testDone()

    tester.startTest("Test Union")

    del bb[:]
    bb2 = bb.copy()
    bb.insert_element(values[0])
    bb.insert_element(values[1])

    bb2.insert_element(values[1])
    bb2.insert_element(values[2])
    rt = bb.create_union(bb2)
    tester.testResults(1,len(rt),done=0,msg='union1')
    tester.testResults(values[1],rt[0],done=0,msg='union2')
    tester.testDone()


    tester.startTest("Test Intersection")
    rt = bb.create_intersection(bb2)
    tester.testResults(3,len(rt),done=0,msg='int1')
    tester.testResults(1,values[0] in rt,done=0,msg='int2')
    tester.testResults(1,values[1] in rt,done=0,msg='int3')
    tester.testResults(1,values[2] in rt,done=0,msg='int4')
    tester.testDone()

    tester.startTest("Test Difference Works")
    rt = bb.create_difference(bb2)
    tester.testResults(2,len(rt),done=0,msg='int1')
    tester.testResults(1,values[0] in rt,done=0,msg='int2')
    tester.testResults(1,values[2] in rt,done=0,msg='int3')
    tester.testDone()


    tester.startTest("Test is Ordered")
    tester.testResults(0,bb.is_ordered(),done=0,msg='ordered')
    tester.testDone()

    tester.startTest("Test is Allows Duplicates")
    tester.testResults(1,bb.allows_duplicates(),done=0,msg='duplicates')
    tester.testDone()




    tester.startTest("Test insert_element and remove_element overrides")

    del bb[:]
    bb.insert_element(values[0])
    bb.insert_element(values[0])
    bb.remove_element(values[0])
    tester.testResults(1,bb.occurrences_of(values[0]),done=0,msg='insert')
    tester.testDone()


def test_collection_of(tester,klass,fac):

    db = Database.Database()

    tester.startTest("append")
    tx = db.new()
    tx.begin()

    values = []
    for ctr in range(3):
        values.append(fac.next())

    otherValue = fac.next()

    col = klass()
    for v in values:
        col.append(v)
    tester.testResults(3,len(col),done=0,msg="append1")

    tx.commit()
    cid = col._4ods_getId()

    tx = db.new()
    tx.begin()

    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    tester.testResults(3,len(col),done=0,msg="append2")
    tester.testDone()

    tester.startTest("values attribute")
    tester.testResults(values,col.value,done=0,msg='value1')
    tester.testDone()

    tester.startTest("subType")
    tester.testResults(fac.getSubType(),col._4ods_getSubType(),done=0,msg='subType1')
    tester.testDone()

    tester.startTest("is Modified apend")
    tester.testResults(0,col._4ods_isModified(),done=0,msg='isModified 1')
    col.append(fac.next())
    tester.testResults(1,col._4ods_isModified(),done=0,msg='isModified 2')
    tester.testDone()

    tester.startTest("count")
    tester.testResults(1,col.count(values[0]),done=0,msg='count1')
    tester.testDone()

    tester.startTest("index")
    tester.testResults(0,col.index(values[0]),done=0,msg='index1')
    tester.testDone()

    tx.abort()

    tester.startTest("insert")
    tx = db.new()
    tx.begin()
    col = klass()

    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    col.append(values[0])
    ctr = 0
    for v in values[1:]:
        col.insert(ctr,v)
        ctr = ctr + 1
    tester.testResults(3,len(col),done=0,msg="insert1")
    tester.startTest("subType")
    tester.testResults(fac.getSubType(),col._4ods_getSubType(),done=0,msg='subType2')
    tester.testDone()

    tx.commit()
    tx = db.new()
    tx.begin()

    cid = col._4ods_getId()

    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    tester.testResults(3,len(col),done=0,msg="insert1")
    tester.testDone()


    tester.startTest("is Modified insert")
    tester.testResults(0,col._4ods_isModified(),done=0,msg='isModified 1')
    col.insert(0,fac.next())
    tester.testResults(1,col._4ods_isModified(),done=0,msg='isModified 2')
    tester.testDone()

    tester.startTest("__getitem__")
    tester.testResults(values[0],col[-1],done=0,msg='getitem 1')
    tester.testResults(values[1],col[1],done=0,msg='getitem 2')
    tester.testDone()

    tx.abort()

    tester.startTest("__delitem__")
    tx = db.new()
    tx.begin()
    
    col = klass()

    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    for v in values:
        col.append(v)

    del col[0]
    tester.testResults(2,len(col),done=0,msg='delitem1')
    tx.commit()
    tx = db.new()
    tx.begin()
    cid = col._4ods_getId()
    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]


    tester.testResults(2,len(col),done=0,msg='delitem2')
    del col[0]
    tester.testResults(1,len(col),done=0,msg='delitem13')
    tx.abort()
    tester.testDone()


    tx = db.new()
    tx.begin()
    cid = col._4ods_getId()
    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    tester.startTest("is Modified delitem")
    tester.testResults(0,col._4ods_isModified(),done=0,msg='delitem 1')
    del col[0]
    tester.testResults(1,col._4ods_isModified(),done=0,msg='delitem 2')
    tester.testDone()
    tx.abort()

    tester.startTest("__setitem__")
    tx = db.new()
    tx.begin()

    col = klass()
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    for v in values:
        col.append(v)

    col[0] = values[0]
    tester.testResults(values[0],col[0],done=0,msg='setitem1')
    tx.commit()

    tx = db.new()
    tx.begin()
    cid = col._4ods_getId()
    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    tester.testResults(values[0],col[0],done=0,msg='setitem2')
    col[0] = otherValue
    tester.testResults(otherValue,col[0],done=0,msg='setitem3')
    tester.testDone()
    tx.abort()
    
    tx = db.new()
    tx.begin()
    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    tester.startTest("is Modified setitem")
    tester.testResults(0,col._4ods_isModified(),done=0,msg='setitem 1')
    col[0] = otherValue
    tester.testResults(1,col._4ods_isModified(),done=0,msg='setitem 2')
    tester.testDone()
    tx.abort()

    tester.startTest('remove')
    tx = db.new()
    tx.begin()
    
    col = klass()
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    for v in values:
        col.append(v)

    col.remove(values[0])
    tester.testResults(values[1],col[0],done=0,msg='remove 1')

    tx.commit()
    tx = db.new()
    tx.begin()
    cid = col._4ods_getId()
    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    tester.testResults(values[1],col[0],done=0,msg='remove 2')
    col.remove(values[1])
    tester.testResults(values[2],col[0],done=0,msg='remove 3')
    tx.abort()
    tester.testDone()

    tx = db.new()
    tx.begin()
    col = tx._4ods_getCollection(cid)
    values = fac.reload(values)
    otherValue = fac.reload([otherValue])[0]

    tester.startTest("is Modified remove")
    tester.testResults(0,col._4ods_isModified(),done=0,msg='remove 1')
    col.remove(values[1])
    tester.testResults(1,col._4ods_isModified(),done=0,msg='remove 2')
    tester.testDone()
    tx.abort()
    return


class LiteralFactory:
    def __init__(self):
        self.ctr = -1
    def next(self):
        self.ctr = self.ctr + 1
        return "TEXT%d"%self.ctr

    def reset(self):
        self.ctr = -1


    def reload(self,values):
        return values
    def getSubType(self):
        return Constants.Types.STRING


class RepoFactory:
    def __init__(self):
        self.ctr = 0
    def next(self):
        m = Module.Module()
        m.name = "Module %d" % self.ctr
        self.ctr = self.ctr + 1
        return m

    def reset(self):
        self.ctr = 0

    def reload(self,values):
        newValues = []
        db = Database.Database()
        tx = db.current()
        for v in values:
            newValues.append(tx._4ods_getRepositoryObject(v._4ods_getId()))
        return newValues

    def getSubType(self):
        return Constants.Types.OBJECT
    
def test_collection(tester,name,klass):

    tester.startGroup(name)

    litFac = LiteralFactory()
    repoFac = RepoFactory()

    curFac = None

    if CollectionOfPersistentObjects.CollectionOfPersistentObjects in klass.__bases__:
        test_collection_of(tester,klass,repoFac)
        curFac = repoFac
    elif CollectionOfValues.CollectionOfValues in klass.__bases__:
        test_collection_of(tester,klass,litFac)
        curFac = litFac
    else:
        raise "Unknwon Collection Of Type %s" % str(inst)

    curFac.reset()

    if ListBase.ListBase in klass.__bases__:
        test_list_base(tester,klass,curFac)
    elif SetBase.SetBase in klass.__bases__:
        test_set_base(tester,klass,curFac)
    elif BagBase.BagBase in klass.__bases__:
        test_bag_base(tester,klass,curFac)
    else:
        raise "Unknwon Collection Type %s" % str(inst)
    
    curFac.reset()

    if LiteralCollection.LiteralCollection in klass.__bases__:
        test_literal_collection(tester,klass)
    else:
        raise "Unknwon Collection Persistent Type %s" % str(inst)

    tester.groupDone()



from Ft.Ods.StorageManager import Adapters
from Ft.Ods.Collections import LiteralCollection
def test(tester):

    #Test all of the colelctions in one big test!

    collections = {'LiteralListOfValues' : LiteralCollection,
                   'LiteralBagOfValues' : LiteralCollection,
                   'LiteralSetOfValues' : LiteralCollection,
                   #'LiteralListOfObjects' : (type(""),),
                   #'LiteralSetOfObjects' : (type(""),),
                   #'LiteralBagOfObjects' : (type(""),),
                   'LiteralListOfRepositoryObjects' : LiteralCollection,
                   'LiteralSetOfRepositoryObjects' : LiteralCollection,
                   'LiteralBagOfRepositoryObjects' : LiteralCollection,
                   }

    #Can't have a full DB here
    manager = Adapters.GetManager()
    adapter = Adapters.GetAdapter()
    if manager.exists(DBNAME):
        manager.reinit(DBNAME,adapter)
    else:
        manager.create(DBNAME)
        manager.init(DBNAME)

    db = Database.Database()
    db.open(DBNAME)

    for name,mod in collections.items():
        c = getattr(mod,name)
        test_collection(tester,name,c)

    db.close()


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)


