
import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

from Ft.Ods import Database
from Ft.Ods.MetaData import Class
from Ft.Ods.StorageManager import Adapters
from Ft.Ods.StorageManager.Adapters import Constants
import test_interface, test_metadata_util

def test(tester):

    manager = Adapters.GetManager()
    adapter = Adapters.GetAdapter()
    if manager.exists(DBNAME):
        manager.reinitRepo(DBNAME,adapter)
    else:
        manager.new(DBNAME,adapter)
    
    db = Database.Database()
    db.open(DBNAME)
    
    test_interface.test(tester,Class.Class)

    tester.startGroup("Class Interface")

    test_metadata_util.test_primitive_collection(tester,Class.Class,'keys','key')
    test_metadata_util.test_primitive_collection(tester,Class.Class,'extents','extent')


    def GetClass():
        from Ft.Ods.MetaData import Class
        c = Class.Class()
        c.name='c1'
        return c
    test_metadata_util.test_form_drop(tester,Class.Class,'extensions',GetClass,nSided=1)
    def GetClass():
        from Ft.Ods.MetaData import Class
        c = Class.Class()
        c.name='c2'
        return c
    test_metadata_util.test_form_drop(tester,Class.Class,'extender',GetClass)

    

    tester.groupDone()


    db.close()


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
