import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

from Ft.Ods import Database
from Ft.Ods.MetaData import Dictionary
from Ft.Ods.MetaData import CollectionKind
from Ft.Ods.StorageManager import Adapters
from Ft.Ods.StorageManager.Adapters import Constants
import test_metadata_collection, test_metadata_util

def test(tester):

    manager = Adapters.GetManager()
    adapter = Adapters.GetAdapter()
    if manager.exists(DBNAME):
        manager.reinitRepo(DBNAME,adapter)
    else:
        manager.new(DBNAME,adapter)
    
    db = Database.Database()
    db.open(DBNAME)
    
    test_metadata_collection.test(tester,Dictionary.Dictionary,is_ordered=0,collectionKind=CollectionKind.CollectionKind.ck_dictionary)

    tester.startGroup("Dictionary Interface")

    def GetType():
        from Ft.Ods import Database
        db = Database.Database()
        return db.schema().resolve('pk_short')
    test_metadata_util.test_form_drop(tester,Dictionary.Dictionary,'key_type',GetType)

    tester.groupDone()


    db.close()


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)

