
import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

from Ft.Ods import Database
from Ft.Ods.MetaData import Module
from Ft.Ods.MetaData import Interface
from Ft.Ods.MetaData import Class
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.StorageManager import Adapters
from Ft.Ods.StorageManager.Adapters import Constants
import test_type
import test_definingscope, test_metadata_util

def test(tester,useKlass=Interface.Interface):

    if useKlass == Interface.Interface:
        manager = Adapters.GetManager()
        adapter = Adapters.GetAdapter()
        if manager.exists(DBNAME):
            manager.reinitRepo(DBNAME,adapter)
        else:
            manager.new(DBNAME,adapter)
            
        db = Database.Database()
        db.open(DBNAME)
    else:
        db = Database.Database()

    
    test_type.test(tester,useKlass)
    test_definingscope.test(tester,useKlass)

    tester.startGroup("Interface test on %s" % useKlass.__name__)

    def GetInterface():
        from Ft.Ods.MetaData import Interface
        i = Interface.Interface()
        i.name='i1'
        return i
    #test_metadata_util.test_form_drop(tester,useKlass,'inherits',GetInterface,nSided=1)
    def GetInterface():
        from Ft.Ods.MetaData import Interface
        i = Interface.Interface()
        i.name='i2'
        return i
    test_metadata_util.test_form_drop(tester,useKlass,'derives',GetInterface,nSided=1)

    def CreateParams():
        db = Database.Database()
        from Ft.Ods.MetaData import Parameter
        from Ft.Ods.MetaData import Direction
        param = Parameter.Parameter(parameter_mode=Direction.Direction.mode_inout)
        param.name = 'param'
        return param
    test_metadata_util.test_add_remove(tester,useKlass,'operation',
                              ("Operation","opResult","Params"),
                              argFactory={"opResult":Class.Class},
                              argListFactory={"Params":CreateParams},
                              argResolve={},
                              testValues={"name":"Operation",
                                          "meta_kind":MetaKind.MetaKind.mk_operation,
                                          "result":"opResult",
                                          },
                              testListValues={'signature':"Params"},
                              testIn="defines",
                              testResolve="Operation",
                              )


    def GetInterface():
        from Ft.Ods.MetaData import Interface
        i = Interface.Interface()
        i.name='i3'
        return i
    test_metadata_util.test_add_remove(tester,useKlass,'attribute',
                              ("Attribute","aType"),
                              argFactory={"aType":GetInterface},
                              argListFactory={},
                              argResolve={},
                              testValues={"name":"Attribute",
                                          "meta_kind":MetaKind.MetaKind.mk_attribute,
                                          "type":"aType",
                                          },
                              testListValues={},
                              testIn="defines",
                              testResolve="Attribute",
                              )
    def GetInterface():
        from Ft.Ods.MetaData import Interface
        i = Interface.Interface()
        i.name='i4'
        return i
    def GetInterface2():
        from Ft.Ods.MetaData import Interface
        i = Interface.Interface()
        i.name='i42'
        return i
    def GetInterface3():
        from Ft.Ods.MetaData import Interface
        i = Interface.Interface()
        i.name='i43'
        return i
    test_metadata_util.test_add_remove(tester,useKlass,'relationship',
                              ("Relationship","rType","Target","InvRel","InvType"),
                              argFactory={"rType":GetInterface,
                                          "Target":GetInterface2,
                                          "InvType":GetInterface3,
                                          },
                              argListFactory={},
                              argResolve={},
                              testValues={"name":"Relationship",
                                          "meta_kind":MetaKind.MetaKind.mk_relationship,
                                          "type":"rType",
                                          },
                              testListValues={},
                              testIn="defines",
                              testResolve="Relationship",
                              )


    tester.groupDone()

    if useKlass == Interface.Interface:
        db.close()







if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
