
import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

from Ft.Ods import Database
from Ft.Ods.MetaData import Literal
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.StorageManager import Adapters
from Ft.Ods.StorageManager.Adapters import Constants
import test_operand
import test_metadata_util

def test(tester):

    manager = Adapters.GetManager()
    adapter = Adapters.GetAdapter()
    if manager.exists(DBNAME):
        manager.reinitRepo(DBNAME,adapter)
    else:
        manager.new(DBNAME,adapter)
    
    db = Database.Database()
    db.open(DBNAME)
    
    test_operand.test(tester,Literal.Literal)


    tester.startGroup("Literal Interface")

    test_metadata_util.test_primitive_type(tester,Literal.Literal,'literal_value',1)

    tester.startTest("value function")

    tx = db.new()
    tx.begin()

    l = Literal.Literal()
    l.literal_value = 1
    tester.testResults(1,l.value(),done=0,msg="value function")

    tx.abort()

    tester.testDone()



    tester.groupDone()

    db.close()



if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
