
from Ft.Ods import Database
from Ft.Ods.MetaData import Collection
from Ft.Ods.MetaData import CollectionKind
from Ft.Ods.MetaData import PrimitiveType
from Ft.Ods.MetaData import Literal
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.StorageManager import Adapters
import test_type,test_metadata_util
import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

class TestWrapper(Collection.Collection):
    def __init__(self,data=None):
        if data is None:
            ck = CollectionKind.CollectionKind.ck_list
        else:
            ck = None
        Collection.Collection.__init__(self,data,collection_kind = ck)

def test(tester,useKlass = Collection.Collection,is_ordered=1,collectionKind=CollectionKind.CollectionKind.ck_list):

    if useKlass == Collection.Collection:
        manager = Adapters.GetManager()
        adapter = Adapters.GetAdapter()
        if manager.exists(DBNAME):
            manager.reinitRepo(DBNAME,adapter)
        else:
            manager.new(DBNAME,adapter)

        db = Database.Database()
        db.open(DBNAME)
        useKlass = TestWrapper
    else:
        db = Database.Database()

    test_type.test(tester,useKlass)

    tester.startGroup("Metadata Collection")

    tester.startTest("Is Ordered")
    tx = db.new()
    tx.begin()
    i = useKlass()
    tester.testResults(is_ordered,i.is_ordered(),done=0,msg="is ordered")
    tester.testDone()
    tester.startTest("collectionKind")
    tester.testResults(collectionKind,i.collection_kind,done=0,msg="collection kind")
    tester.testDone()
    tester.startTest("bound")
    tester.warning("What does bound mean??")
    tester.testDone()
    tx.abort()

    def GetInterface():
        from Ft.Ods.MetaData import Interface
        i = Interface.Interface()
        i.name='c2'
        return i
    test_metadata_util.test_form_drop(tester,useKlass,'subtype',GetInterface)
    test_metadata_util.test_form_drop(tester,useKlass,'max_size',Literal.Literal)

    tester.groupDone()

    if useKlass == TestWrapper:
        db.close()

if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
