
import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

from Ft.Ods import Database
from Ft.Ods.MetaData import Module
from Ft.Ods.MetaData import Interface
from Ft.Ods.MetaData import Class
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.StorageManager import Adapters
from Ft.Ods.StorageManager.Adapters import Constants
import test_metaobject
import test_definingscope
import test_metadata_util
def test(tester,useKlass=Module.Module):



    manager = Adapters.GetManager()
    adapter = Adapters.GetAdapter()
    if manager.exists(DBNAME):
        manager.reinitRepo(DBNAME,adapter)
    else:
        manager.new(DBNAME,adapter)
    
    db = Database.Database()
    db.open(DBNAME)
    
    test_metaobject.test(tester,useKlass)
    test_definingscope.test(tester,useKlass)

    tester.startGroup("Module Interface")


    test_metadata_util.test_add_remove(tester,useKlass,'module',
                              ("Module",),
                              argFactory={},
                              argListFactory={},
                              argResolve={},
                              testValues={"name":"Module",
                                          "meta_kind":MetaKind.MetaKind.mk_module,
                                          },
                              testListValues={},
                              testIn="defines",
                              testResolve="Module",
                              )

    def CreateInherits():
        from Ft.Ods.MetaData import Interface
        inherits = Interface.Interface()
        inherits.name = "Mo"
        return inherits
    test_metadata_util.test_add_remove(tester,useKlass,'interface',
                              ("Interface","Inherits"),
                              argFactory={},
                              argListFactory={"Inherits":CreateInherits},
                              argResolve={},
                              testValues={"name":"Interface",
                                          "meta_kind":MetaKind.MetaKind.mk_interface,
                                          },
                              testListValues={"inherits":"Inherits"},
                              testIn="defines",
                              testResolve="Interface",
                              )
    def CreateInherits():
        from Ft.Ods.MetaData import Interface
        inherits = Interface.Interface()
        inherits.name = "Mo2"
        return inherits
    def CreateExtend():
        from Ft.Ods.MetaData import Class
        inherits = Class.Class()
        inherits.name = "Mo4"
        return inherits
    test_metadata_util.test_add_remove(tester,useKlass,'class',
                              ("Class","Inherits","Extend"),
                              argFactory={"Extend":CreateExtend},
                              argListFactory={"Inherits":CreateInherits},
                              argResolve={},
                              testValues={"name":"Class",
                                          "meta_kind":MetaKind.MetaKind.mk_class,
                                          "extender":"Extend"
                                          },
                              testListValues={"inherits":"Inherits"},
                              testIn="defines",
                              testResolve="Class",
                              )

    tester.groupDone()


    db.close()


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
