
import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

from Ft.Ods import Database
from Ft.Ods.MetaData import Operation
from Ft.Ods.MetaData import Parameter
from Ft.Ods.MetaData import Interface
from Ft.Ods.MetaData import Exception
from Ft.Ods.StorageManager import Adapters
from Ft.Ods.StorageManager.Adapters import Constants
import test_metaobject
import test_metadata_util

def test(tester):

    manager = Adapters.GetManager()
    adapter = Adapters.GetAdapter()
    if manager.exists(DBNAME):
        manager.reinitRepo(DBNAME,adapter)
    else:
        manager.new(DBNAME,adapter)
    
    db = Database.Database()
    db.open(DBNAME)
    
    test_metaobject.test(tester,Operation.Operation)


    tester.startGroup("Operation Interface")
    tester.startTest("Scope")
    tester.warning("No Scope Support")
    tester.testDone()

    def GetParameter():
        from Ft.Ods.MetaData import Parameter
        from Ft.Ods.MetaData import Direction
        return Parameter.Parameter(parameter_mode = Direction.Direction.mode_in)
    test_metadata_util.test_form_drop(tester,Operation.Operation,'signature',GetParameter,nSided=1)
    test_metadata_util.test_form_drop(tester,Operation.Operation,'result',Interface.Interface)
    test_metadata_util.test_form_drop(tester,Operation.Operation,'exceptions',Exception.Exception,nSided=1)

    tester.groupDone()

    db.close()



if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
