
from Ft.Ods import Database
from Ft.Ods.MetaData import PrimitiveType
from Ft.Ods.MetaData import PrimitiveKind
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.StorageManager import Adapters


import os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

def test(tester):

    tester.startGroup("Primitive Type")

    tester.startTest("Init DB")
    manager = Adapters.GetManager()
    adapter = Adapters.GetAdapter()
    if manager.exists(DBNAME):
        manager.reinitRepo(DBNAME,adapter)
    else:
        manager.new(DBNAME,adapter)
    tester.testDone()


    db = Database.Database()
    db.open(DBNAME)
    tx = db.new()
    tx.begin()

    tester.startTest("Create Primitive Type")
    repo = db.schema()
    t = repo.create_primitive_type(PrimitiveKind.PrimitiveKind.pk_short)
    t.name = 'new short'
    repo.add_defines(t)
    tx.commit()

    id = t._4ods_getId()

    tester.testDone()
    tester.startTest("Retrieve Type")

    tx = db.new()
    tx.begin()

    t = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)
    tester.testResults('new short',t.name,done=0,msg='pt1')
    tx.commit()

    tester.testDone()

    tester.groupDone()

    db.close()

if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
