import os, string, time
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")
import time

from Ft.Ods.StorageManager.Adapters import Constants

class Foo:
    pass


class DummyCollection:
    pass


def test_management(mang,val):

    #Create
    rt = mang.create(DBNAME)
    if not val.validateCreate(DBNAME):
        raise "Create Failed"
    #Exists
    if not mang.exists(DBNAME):
        raise "Exists failed"

    #Destroy
    mang.destroy(DBNAME)
    if not val.validateDestroy(DBNAME):
        raise "Destroy Failed"
    


    #Test basic initialization
    mang.create(DBNAME)
    mang.init(DBNAME)

    #tables = val.getTableInfo(DBNAME)

    #for t in mang.tables.keys():
    #    #Make sure it atleast has the defined keys
    #    for attrData in mang.tables[t][mang.TableData.TABLE_INIT]:
    #        if not string.lower(attrData[0]) in tables[t]:
    #            raise "Missing %s on table %s" % (attrData[0],t)
    
    time.sleep(1)
    mang.destroy(DBNAME)
    

def test_full_management(mang,adapter,val):

    if mang.exists(DBNAME):
        mang.destroy(DBNAME)
    #Try to create a full database
    mang.new(DBNAME,adapter)


def test_python_classes(mang,adapter,val):

    if mang.exists(DBNAME):
        mang.destroy(DBNAME)
    mang.create(DBNAME)
    mang.init(DBNAME)

    #Add a simple repository object (a primitive type)
    db = mang.connect(DBNAME)

    adapter.begin(db)

    pid = adapter.newPythonClass(db,Foo)

    print adapter.getPythonClass(db,pid)

    adapter.deletePythonClass(db,pid)
    
    print adapter.getPythonClass(db,pid)


    adapter.commit(db)

    #mang.destroy(DBNAME)

def test_basic_repos(mang,adapter,val):

    if mang.exists(DBNAME):
        mang.destroy(DBNAME)
    mang.create(DBNAME)
    mang.init(DBNAME)

    #Add a simple repository object (a primitive type)
    db = mang.connect(DBNAME)

    adapter.begin(db)

    adapter.newPythonClass(db,Foo)


    types = (13, 41, 9, 9, 37, 39, 39, 39, 39, 39, 39, 39, 39, 41)
    Foo._tupleTypes = types
    
    rid = adapter.newRepositoryObjectId(db,14,Foo)
    rid = adapter.newRepositoryObjectId(db,14,Foo,12345)
    print rid

    names = ('_repoId', 'meta_kind', 'name', 'comment', 'definedIn', 'collections', 'dictionaries', 'specifiers', 'unions', 'operations', 'properties', 'constants', 'type_defs', 'primitive_kind')

    values = (rid,14,"Test Type","Comment",0,0,0,0,0,0,0,0,0,3)

    adapter.writeRepositoryObject(db,14,rid,types,names,values)

    if not adapter.objectUptoDate(db,Constants.ObjectTypes.REPO,rid,time.time()):
        raise "Bad upto date"
    if adapter.objectUptoDate(db,Constants.ObjectTypes.REPO,rid,time.time()-20):
        raise "Bad uptodate"


    print adapter.getRepositoryObject(db,rid)

    adapter.deleteRepositoryObject(db,rid,14)

    adapter.commit(db)

    del db

    mang.destroy(DBNAME)


def test_extents(mang,adapter,val):
    if mang.exists(DBNAME):
        mang.destroy(DBNAME)
    mang.create(DBNAME)
    mang.init(DBNAME)

    db = mang.connect(DBNAME)

    adapter.begin(db)


    adapter.addExtent(db,"test",Constants.ObjectTypes.REPO)

    print adapter.extentNames(db)

    adapter.addExtentEntry(db,['test'],15)
    adapter.addExtentEntry(db,['test'],16)

    print adapter.loadExtent(db,'test')
    print adapter.loadExtent(db,'foo')


    adapter.dropExtentEntry(db,['test'],15)
    adapter.dropExtent(db,"test")


    adapter.commit(db)

    mang.destroy(DBNAME)



def test_bindings(mang,adapter,val):
    if mang.exists(DBNAME):
        mang.destroy(DBNAME)
    mang.create(DBNAME)
    mang.init(DBNAME)

    db = mang.connect(DBNAME)

    adapter.begin(db)

    adapter.bind(db,15,'test1')
    adapter.bind(db,16,'test2')

    print adapter.getAllBindings(db)
    print adapter.getObjectBindings(db,15)
    print adapter.lookup(db,'test2')
    print adapter.lookup(db,'foo')


    adapter.commit(db)

    mang.destroy(DBNAME)


def test_collections(mang,adapter,val):
    if mang.exists(DBNAME):
        mang.destroy(DBNAME)
    mang.create(DBNAME)
    mang.init(DBNAME)

    db = mang.connect(DBNAME)

    adapter.begin(db)

    adapter.newPythonClass(db,DummyCollection)

    cid = adapter.newCollection(db,DummyCollection,None,Constants.Types.STRING)
    print cid

    changes = [(Constants.CollectionChanges.APPEND,[('1',0),('2',1)])]

    adapter.writeCollection(db,cid,changes,None,Constants.Types.STRING)

    changes = [(Constants.CollectionChanges.INSERT,[('1.5',1)])]

    adapter.writeCollection(db,cid,changes,None,Constants.Types.STRING)

    changes = [(Constants.CollectionChanges.REMOVE,[0])]

    adapter.writeCollection(db,cid,changes,None,Constants.Types.STRING)

    adapter.deleteCollection(db,cid,None,Constants.Types.STRING)

    adapter.commit(db)

    #mang.destroy(DBNAME)


def test_blobs(mang,adapter,val):
    if mang.exists(DBNAME):
        mang.destroy(DBNAME)
    mang.create(DBNAME)
    mang.init(DBNAME)

    db = mang.connect(DBNAME)

    adapter.begin(db)

    bid = adapter.newBlob(db)

    adapter.writeBlob(db,bid,"This is a test")
    print adapter.readBlob(db,bid)
    adapter.deleteBlob(db,bid)

    #try:
    print adapter.readBlob(db,bid)
    #except:
    #    pass
    #else:
    #    raise "No Exception??"

    adapter.commit(db)

    del db

    time.sleep(1)

    #mang.destroy(DBNAME)


