from Ft.Ods.StorageManager.Adapters import Constants


odl_string = '''
module Test {

class Professor;

class Student
{
	attribute string name;
        attribute string ssn;
	relationship Professor learns_from inverse Test::Professor :: teaches;
};

class Professor
{
	attribute string name;
	relationship list<Student> teaches inverse Student :: learns_from;
};
};
'''



def test():
    from Ft.Ods import Database
    from Ft.Ods import StorageManager

    from Ft.Ods.Parsers.Odl import OdlParse
    OdlParse.parse(1,1,'test',1,'',0,odl_string)

    from Test import Student
    from Test import Professor


     #First create a couple of instances so we can dump something
     

    db = Database.Database()
    db.open('test')

    tx = db.new()
    tx.begin()

    s1 = Student.new()
    s1.name = "Student 1"
    s1.ssn = "SSN1"

    s2 = Student.new()
    s2.name = "Student 2"
    s2.ssn = "SSN2"

    p1 = Professor.new()
    p1.name = "Professor 1"

    p2 = Professor.new()
    p2.name = "Professor 2"

    s1.learns_from = p1
    s2.learns_from = p1

    tx.commit()

    tx = db.new()
    tx.begin()

    sm = StorageManager.StorageManager('test')

    print sm._4ods_dumpOif()

    db.close()


if __name__ == '__main__':

    import sys
    if len(sys.argv) > 1:
        import os
        os.system('4odb_destroy.py test')
        os.system('4odb_create.py test')

    import time
    start = time.time()
    test()
    end = time.time()
    print "Total Time %f" % (end - start)
