from Ft.Ods.StorageManager.Adapters import Constants


odl_string = '''
module Test {

class Professor;

class Student
{
	attribute string name;
	relationship Professor learns_from inverse Test::Professor :: teaches;
};

class Professor
{
	attribute string name;
	relationship list<Student> teaches inverse Student :: learns_from;
};

};

'''



def test():
    from Ft.Ods import Database
    from Ft.Ods import StorageManager

    from Ft.Ods.Parsers.Odl import OdlParse
    OdlParse.parse(1,1,'test',1,'',0,odl_string)

    from Test import Student


    import sys

    db = Database.Database()
    db.open('test')

    tx = db.new()
    tx.begin()

    sm = StorageManager.StorageManager('test')
    sm._4ods_loadOif(sys.stdin.read())

    tx.commit()

    tx = db.new()
    tx.begin()

    print sm._4ods_dumpOif()

    #tx.commit()

    db.close()


if __name__ == '__main__':

    import sys
    if len(sys.argv) > 1:
        import os
        os.system('4odb_destroy.py test')
        os.system('4odb_create.py test')

    import time
    start = time.time()
    test()
    end = time.time()
    print "Total Time %f" % (end - start)
