

from Ft.Ods.StorageManager import Adapters
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.StorageManager import GlobalCache

import os, string, time
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

class DummyPO:
    _tupleTypes = (13, 41, 9, 9, 37, 39, 39, 39, 39, 39, 39, 39, 39, 41)

    pass

def test(tester):

    tester.startGroup("Global Cache")
    tester.startTest("Init DB")
    mang = Adapters.GetManager()
    adapter = Adapters.GetAdapter()

    gc = GlobalCache.GlobalCache()
    
    if mang.exists(DBNAME):
        mang.reinit(DBNAME,adapter)
    else:
        mang.create(DBNAME)
        mang.init(DBNAME)

    tester.testDone()

    tester.startTest("Add a Repo Object")
    db = mang.connect(DBNAME)
    adapter.begin(db)
    adapter.newPythonClass(db,DummyPO)
    rid = adapter.newRepositoryObjectId(db,14,DummyPO)
    names = ('_repoId', 'meta_kind', 'name', 'comment', 'definedIn', 'collections', 'dictionaries', 'specifiers', 'unions', 'operations', 'properties', 'constants', 'type_defs', 'primitive_kind')
    values = (rid,14,"Test Type","Comment",0,0,0,0,0,0,0,0,0,3)
    adapter.writeRepositoryObject(db,14,rid,DummyPO._tupleTypes,names,values)
    adapter.commit(db)

    tester.testDone()

    tester.startTest("Get the Repo Object")
    db = mang.connect(DBNAME)
    adapter.begin(db)

    tester.testResults(None,gc.getObject(adapter,db,Constants.ObjectTypes.REPO,rid),done=0,msg='Get Empty')
    _klass,data = adapter.getRepositoryObject(db,rid)
    gc.registerObject(Constants.ObjectTypes.REPO,rid,(_klass,data))
    tester.testResults((_klass,data),gc.getObject(adapter,db,Constants.ObjectTypes.REPO,rid),done=0,msg="Get Not Empty")
    
    tester.testDone()

    tester.startTest("Purge")

    gc.registerObject(Constants.ObjectTypes.REPO,rid,(_klass,data))
    gc.purge(time.time()-100)
    tester.testResults((_klass,data),gc.getObject(adapter,db,Constants.ObjectTypes.REPO,rid),done=0,msg="No Purge")
    gc.purge(time.time()+1)
    tester.testResults(None,gc.getObject(adapter,db,Constants.ObjectTypes.REPO,rid),done=0,msg="Purge")
    adapter.commit(db)

    tester.testDone()

    del db

    tester.groupDone()


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
