import os

#
# A script to put some interesting data into the database to test out DIG
#


odl_string = '''
module Test {

class Professor;
const string TEST="test";
class Student (extent students)
{
        const string CLASS_CONST = "CLASS";
	attribute string name;
        relationship Professor taught_by inverse Professor::teaches;

};

enum Day {Mon,Tue,Wed,Thu,Fri,Sat,Sun};

class Professor {
    attribute string name;
    attribute Day dayOff;
    relationship list<Student> teaches inverse Student::taught_by;
  };
    
};
'''
#'

DBNAME=os.environ.get("ODS_TEST_DB","ods:test")


def test():
    from Ft.Ods import Database



    from Ft.Ods import FtodsBindingException

    from Test import Student
    from Test import Professor
    from Test import Day

    db = Database.Database()
    db.open(DBNAME)

    tx = db.new()
    tx.begin()


    s1 = Student.new()
    s1.name = "Mike Olson"

    s2 = Student.new()
    s2.name = "Uche Ogbuji"

    s3 = Student.new()
    s3.name = "Vicki Roberts"

    p1 = Professor.new()
    p1.name = "Matt Treu"
    p1.dayOff = Day.Day.Tue

    p2 = Professor.new()
    p2.name = "God"
    p1.dayOff = Day.Day.Sun

    s1.taught_by = p1
    s2.taught_by = p1

    db.bind(p1,"Matt Treu")
    db.bind(p2,"God")

    
    tx.commit()
    
    
    


if __name__ == '__main__':

    import os
    os.system('4odb_destroy %s'%DBNAME)
    os.system('4odb_create %s'%DBNAME)
    from Ft.Ods.Parsers.Odl import OdlParse
    OdlParse.parse(1,0,DBNAME,1,'',odl_string)

    test()
