import os

#
#Note: While testing it might be useful to use
#
#export TRACEOUT=4ODS:4Suite.PgDatabase
#export TRACEOUT_FLAGS=LABEL
#
#Requires the database to be set up with the schema from varsity1.odl or varsity2.odl
#
#Typical test process:
#
#python ../Tools/4odb_destroy.py test
#python ../Tools/4odb_create.py test
#python ../Parsers/OdlParse.py -d -p -i --db=test varsity1.odl
#python basic_test1.py
#


from Test import Professor
from Test import Student

from Ft.Ods.StorageManager.Adapters import Constants

def testDbOpen(num):

    for ctr in range(num):
        db = Database.Database()
        db.open('test')
        db.close()
        Database._Database.__instance = None
        




def testInsert(num):

    for ctr in range(num):
        db = Database.Database()
        db.open('test')

        tx = db.new()
        tx.begin()

        p = Professor.new()

        tx.commit()

    return p._4ods_getOid()

def testInsertStr(num,st):

    for ctr in range(num):
        db = Database.Database()
        db.open('test')

        tx = db.new()
        tx.begin()

        p = Professor.new()
        p.name = st

        tx.commit()

    return p._4ods_getOid()

def testFetch(num,id):

    for ctr in range(num):
        db = Database.Database()
        db.open('test')

        tx = db.new()
        tx.begin()

        p = db._4ods_getPersistentObjectById(Constants.ObjectTypes.OBJECT,id)
        tx.commit()

    return



    p.ssn = '666-123-1234'
    p.name = 'Eblis Einstein'

    s.ssn = '123-456-7890'
    s.name = 'Maro Faustus'

    p.form_teaches(s)

    print p.teaches
    print s.learns_from

    tx.commit()

    id = p._4ods_getOid()

    tx = db.new()
    tx.begin()

    p = db._4ods_getPersistentObjectById(Constants.ObjectTypes.OBJECT,id)

    print p
    print p.ssn
    print p.name
    print p.teaches
    print p.teaches.learns_from

    ext = db.lookup('students')
    print ext
    print ext._4ods_getContents()

    return




    p.add_teaches(s)
    print "*** Inverse Relationship from new Student to:", s.learns_from

    if not db.lookup('Einstein'):
        db.bind(p, 'Einstein')

    tx.commit()

    print p._ftods_getOid()

    tx = db._ftods_getTxFactory().new()
    tx.begin()

    p = db.lookup('Einstein')
    print "*** Teaches relationships: ", p.teaches
    s = p.teaches.retrieve_first_element()
    print "*** First teaches relationship:", s
    print "*** First Student SSN: ", s.ssn
    print "*** First Student Name: ", s.name

    s1 = Student.new(db)
    print "*** s1 id: ", hex(id(s1))

    p.add_teaches(s1)
    print "*** Inverse Relationship from new Student to: ", s1.learns_from

    tx.commit()

    tx = db._ftods_getTxFactory().new()
    tx.begin()

    guy_fawkes = Professor.new(db)
    db.bind(guy_fawkes, 'Guy Fawkes')

    tx.commit()

    tx = db._ftods_getTxFactory().new()
    tx.begin()

    gf = db.lookup('Guy Fawkes')
    gf.delete()

    tx.commit()

    tx = db._ftods_getTxFactory().new()
    tx.begin()

    gf = db.lookup('Guy Fawkes')
    print "*** This should be 'None':", gf

    tx.commit()

if __name__ == '__main__':


    from Ft.Ods import Database
    import time


    print "Time to open a database"
    start = time.time()
    testDbOpen(500)
    end = time.time()
    ave = float(end - start)/500.0
    print "%f secs" % ave

    print "Time to insert empty object"
    start = time.time()
    testInsert(500)
    end = time.time()
    ave = float(end - start)/500.0
    print "%f secs" % ave

    print "Time to insert object w/ string"
    st = '*' * 1024
    start = time.time()
    id = testInsertStr(500,st)
    end = time.time()
    ave = float(end - start)/500.0
    print "%f secs" % ave

    print "Time to fetch"
    st = '*' * 1024
    start = time.time()
    testFetch(500,id)
    end = time.time()
    ave = float(end - start)/500.0
    print "%f secs" % ave

    

