import os

#Test multiple threads leaving and joining a transaction

odl_string = '''
class Foo
{
	attribute short threadNum;
};

'''
#'

NUM_THREADS = 10

from Ft.Ods import Database
import threading
import time

g_curThread = -1

g_tx = None

DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

import sys, test_util
from Ft.Ods import Database
from Ft.Ods.StorageManager.Adapters import Constants
    
def test(tester):

    tester.startGroup("Leave and Join")

    test_util.DbInit(DBNAME,odl_string)

    tester.startTest('Testing Generated syntax')
    try:
        import Foo
        reload(Foo)
    except:
        tester.error('Error in syntax', 1)


    tester.testDone()

    db = Database.Database()
    db.open(DBNAME)


    tester.startTest("Run the threads")
    threads = []
    for ctr in range(NUM_THREADS):
        t = threading.Thread(None,test_thread,"Thread-%i"%ctr,(ctr,))
        t.start()
        threads.append(t)
        
    global g_tx
    g_tx = db.new()
    g_tx.begin()

    obj = Foo.new()
    obj.threadNum = -1
    db.bind(obj,"Foo")

    g_tx.leave()

    
    global g_curThread
    g_curThread = 0

    while g_curThread != NUM_THREADS:
        time.sleep(2)

    
    g_tx.join()
    g_tx.commit()

    tester.testDone()
    tester.groupDone()
    db.close()



def test_thread(threadNum):
    global g_tx,g_curThread

    while g_curThread != threadNum:
        time.sleep(1)
    db = Database.Database()
    g_tx.join()

    f = db.lookup("Foo")
    f.threadNum = threadNum

    

    g_tx.leave()
    g_curThread = g_curThread + 1






if __name__ == '__main__':


    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1, 1)

    retVal = test(tester)
    sys.exit(retVal)


