
class FakeCompiledObject:
    def __init__(self):
        pass


def test(db):


    from Ft.Lib import TestSuite
    test = TestSuite.TestSuite()
    test.startGroup('Driver Interface Test')

    test.startTest("Begin")
    db.begin()
    test.testDone()

    test.startTest("Add Statements")
    db.add([('Book','Author','Mike Olson','uri'),
            ('Book','Publisher','AWL','uri'),
            ('Book','Printer','Free Press','uri'),
            ])
    test.testDone()

    test.startTest("Remove Statement")
    db.remove([('Book','Printer','Free Press','uri')])
    test.testDone()

    test.startTest("Test Complete with Parameters 1,2,3")
    rt = db.complete('Book','Author','Mike Olson')
    if rt[0] != ('Book','Author','Mike Olson','uri') and len(rt) != 1:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Complete with parameters 1,2")
    rt = db.complete('Book','Author',None)
    if rt[0] != ('Book','Author','Mike Olson','uri') and len(rt) != 1:
        test.error('Wrong results', 1)
    test.testDone()


    test.startTest("Test Complete with parameters 1")
    rt = db.complete('Book','',None)
    if rt[0] != ('Book','Author','Mike Olson','uri') and len(rt) != 1:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Complete with parameters 2")
    rt = db.complete('','Author',None)
    if rt[0] != ('Book','Author','Mike Olson','uri') and len(rt) != 1:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Complete with parameters 2,3 (empty results)")
    rt = db.complete('','Author','Jimmy')
    if len(rt) != 0:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Complete with parameters 3 ")
    rt = db.complete('','','AWL')
    if rt[0] != ('Book','Publisher','AWL') and len(rt) != 1:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Complete with no parameters")
    rt = db.complete('','','AWL')
    if rt[0] != ('Book','Publisher','AWL','uri') and rt[1] != ('Book','Publisher','AWL','uri') and len(rt) != 2:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Size")
    if db.size() != 2:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Contains with expected result")
    if not db.contains('Book','Author','Mike Olson','uri'):
        test.error('Wrong results', 1)
    test.testDone()

        
    test.startTest("Test Contains without expected result")
    if db.contains('Book','Author','John','uri'):
        test.error('Wrong results', 1)
    test.testDone()


    fco = FakeCompiledObject()

    test.startTest("Test Bind")
    db.bind(fco,"TEST")
    test.testDone()

    test.startTest("Test Lookup")
    if db.lookup("TEST") != fco:
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test Lookup (no results)")
    if db.lookup("TEST2"):
        test.error('Wrong results', 1)
    test.testDone()

    test.startTest("Test UnBind")
    db.unbind("TEST")
    if db.lookup("TEST"):
        test.error('Wrong results', 1)
    test.testDone()
    
        
    

    



    test.startTest("Test Commit")
    db.commit()
    test.testDone()
