


def test(driverFactory):

    from Ft.Rdf import Model
    from Ft.Rdf.Inference import InferenceEngine

    try:
        driverFactory.DestroyDb('kb')
    except:
        pass
    try:
        db = driverFactory.CreateDb('kb')
    except:
        db = driverFactory.DbAdapter('kb')
 
 
    m = Model.Model('',db)
    infeng = InferenceEngine.InferenceEngine(m,[])

    db.begin()

    exp = """<?xml version = "1.0"?>
<ril:expression xmlns:ril = "http://namespaces.rdfinference.org/ril" xmlns:ft = "http://namespaces.fourthought.com/test">
  <ril:rule>
    <ril:premise>
      <ft:running>
        <ril:variable name='X'/>
      </ft:running>
    </ril:premise>
    <ril:conclusion>
      <ril:assert>
        <ft:sweating>
          <ril:variable name='X'/>
        </ft:sweating>
      </ril:assert>
    </ril:conclusion>
  </ril:rule>
  <ril:rule>
    <ril:premise>
      <ft:sweating>
        <ril:variable name='X'/>
      </ft:sweating>
    </ril:premise>
    <ril:conclusion>
      <ril:assert>
        <ft:wet>
          <ril:variable name='X'/>
        </ft:wet>
      </ril:assert>
    </ril:conclusion>
  </ril:rule>
  <ril:assert>
    <ft:running><ril:string>Mike</ril:string></ft:running>
  </ril:assert>
  <ril:query>
    <ft:wet><ril:variable name='X'/></ft:wet>
  </ril:query>
</ril:expression>"""

    obj = m.compileRil(exp)

    print obj

    print obj.execute(infeng)

    m.bind(obj,"TEST")

    db.commit()

    db.begin()

    print m.lookup("TEST")
    
    print m.lookup("FOO")

    db.rollback()



if __name__ == '__main__':
    from Ft.Rdf.Drivers import Postgres

    test(Postgres)
