


def test(test,driver):
    test.startGroup('Basic Modl Interface')
    
    from Ft.Rdf import Statement

    db = driver.CreateDb('test')
    db.begin()

    from Ft.Rdf import Model
    m = Model.Model('',db)


    test.startTest('add')

    s = Statement.Statement('Book','Author','Mike Olson','http://foo.com')
    m.add(s)
    if len(m.statements()) != 1:
        test.error('Add Failed', 1)
    test.testDone()
        
    test.startTest('remove')

    m.remove(s)
    if len(m.statements()) != 0:
        test.error('Remove Failed', 1)
    test.testDone()


    test.startTest('complete')
    stmts = []
    for subj in ['a','b','c']:
        s = Statement.Statement(subj,'Author','Mike Olson','http://foo.com')
        stmts.append(s)
    
    m.add(stmts)
    if len(m.statements()) != 3:
        test.error('Add Failed', 1)

    if len(m.complete('a',None,None)) != 1:
        test.error('Complete Failed', 1)
        
    if len(m.exclude('a',None,None)) != 2:
        test.error('Complete Failed', 1)
        
    test.testDone()




    db.rollback()



if __name__ == '__main__':
    import sys
    from Ft.Rdf.Drivers import Memory
    from Ft.Lib import TestSuite

    driver = Memory
    testmgr = TestSuite.TestSuite()
    ret_val = test(testmgr,driver)
    sys.exit(ret_val)
