
def test(test,driver):
    test.startGroup('Basic Modl Interface')
    
    db = driver.CreateDb('test')
    db.begin()

    from Ft.Rdf import Model
    from Ft.Rdf import ResourceDict
    from Ft.Rdf.Statement import Statement
    m = Model.Model('',db)


    test.startTest('init')

    m.add([Statement('molson','fullname','Mike Olson'),
           Statement('uogbuji','fullname','Uche Ogbuji'),
           Statement('jkloth','fullname','Jeremy Kloth'),
           Statement('Fourthought','employee','molson'),
           Statement('Fourthought','employee','uogbuji'),
           Statement('Fourthought','employee','jkloth'),
           Statement('Fourthought','name','Fourthought, Inc.'),
           ])

    test.testDone()

    test.startTest('access')

    ft = ResourceDict.CreateResourceDict(m,'Fourthought')

    test.testResults(ResourceDict.ResourceDict,ft.__class__,done=0)
    test.testResults(['Fourthought, Inc.'],ft['name'],done=0)
    test.testResults(3,len(ft['employee']),done=0)
    test.testResults(['Mike Olson'],ft['employee'][0]['fullname'],done=0)
    test.testResults(['Uche Ogbuji'],ft['employee'][1]['fullname'],done=0)
    test.testResults(['Jeremy Kloth'],ft['employee'][2]['fullname'],done=0)
    test.testDone()
    
    test.startTest('set')

    ft['city'] = 'Boulder'
    test.testResults(['Boulder'],ft['city'],done=0)

    test.testDone()
    
    test.startTest('delete')

    del ft['city']

    try:
        x = ft['city']
    except KeyError, e:
        pass
    else:
        test.testError("Shoulda thrown an exception")

    test.testDone()

    test.startTest('misc functions')

    test.testResults(2,len(ft),done=0)
    test.testResults(2,len(ft.keys()),done=0)
    test.testResults('employee',ft.keys()[0],done=0)
    test.testResults('name',ft.keys()[1],done=0)
    test.testResults(2,len(ft.items()),done=0)
    test.testResults('employee',ft.items()[0][0],done=0)
    test.testResults('name',ft.items()[1][0],done=0)
    test.testResults(2,len(ft.values()),done=0)
    test.testResults(0,ft.has_key('foo'),done=0)
    test.testResults(1,ft.has_key('name'),done=0)
    test.testResults(None,ft.get('foo'),done=0)
    test.testResults(['Fourthought, Inc.'],ft.get('name'),done=0)


    test.testDone()
    

if __name__ == '__main__':
    import sys
    from Ft.Rdf.Drivers import Memory
    from Ft.Lib import TestSuite

    driver = Memory
    testmgr = TestSuite.TestSuite()
    ret_val = test(testmgr,driver)
    sys.exit(ret_val)
