


def test(test,driver):
    test.startGroup('Basic Modl Interface')
    
    from Ft.Rdf import Statement

    try:
        db = driver.DestroyDb('test')
    except:
        pass

    try:
        db = driver.CreateDb('test')
    except:
        db = driver.DbAdapter('test')
    db.begin()

    from Ft.Rdf import Model
    m = Model.Model('',db)


    test.startTest('Regex complete')
    stmts = []
    for subj in ['a','b','c']:
        s = Statement.Statement(subj,'Author','Mike Olson','http://foo.com')
        stmts.append(s)
    
    m.add(stmts)
    test.compare(3,len(m.statements()))

    if len(m.completeRegex('.?','Author','Mike Olson')) != 3:
        test.error('Complete Failed', 1)
    if len(m.completeRegex(None,'a.?thor','Mike Olson',1)) != 3:
        test.error('Complete Failed', 1)
        
    test.testDone()




    db.rollback()



if __name__ == '__main__':
    import sys
    from Ft.Rdf.Drivers import Memory
    from Ft.Rdf.Drivers import Postgres
    from Ft.Lib import TestSuite

    #driver = Memory
    driver = Postgres
    testmgr = TestSuite.TestSuite()
    ret_val = test(testmgr,driver)
    sys.exit(ret_val)
