#!/usr/bin/env python
#
# File Name:        File Name
#
# Documentation:    http://docs.fourthought.com/file/name.html
#


from xml.dom import ext
from xml.dom.ext.reader import Sax2
from xml.dom import Comment, Node

xml = """
<?xml-stylesheet "Data" ?>
<ROOT>
  <!-- Test Comment -->
  <CHILD1 attr1="val1" >
    <GCHILD name="GCHILD11"/>
    <GCHILD name="GCHILD12"/>
    Text1
  </CHILD1>
  <CHILD2 attr1="val2" ID="1">
    <GCHILD name="GCHILD21"/>
    <GCHILD name="GCHILD22"/>
  </CHILD2>
  <foo:CHILD3 xmlns:foo="http://foo.com" foo:name="mike"/>
</ROOT>
<?no-data ?>
"""


DOM = Sax2.FromXml(xml)
DOM = ext.StripHtml(DOM)
PI = DOM.firstChild
PI2 = DOM.lastChild
ROOT = DOM.documentElement
COMMENT = Comment.Comment(DOM,'Test Comment')
# Comments are ignored by the parser, add it ourselves
ROOT.insertBefore(COMMENT,ROOT.firstChild)
CHILDREN = filter(lambda n: n.nodeType == Node.ELEMENT_NODE,
                  ROOT.childNodes)
CHILD1 = CHILDREN[0]
ATTR1 = CHILD1.getAttributeNodeNS('', 'attr1')
GCHILDREN1 = list(CHILD1.getElementsByTagNameNS('', 'GCHILD'))
GCHILD11 = GCHILDREN1[0]
GCHILD12 = GCHILDREN1[1]
TEXT1 = CHILD1.lastChild
CHILD2 = CHILDREN[1]
ATTR12 = CHILD2.getAttributeNodeNS('', 'attr1')
GCHILDREN2 = list(CHILD2.getElementsByTagNameNS('', 'GCHILD'))
GCHILD21 = GCHILDREN2[0]
GCHILD22 = GCHILDREN2[1]
CHILD3 = CHILDREN[2]
ATTR2 = CHILD3.getAttributeNodeNS('http://foo.com','name')


def PrintList(list):
    for l in list:
        tag_data = l.nodeName
        attrs = l.attributes or []
        for attr in (l.attributes or []):
            tag_data = tag_data + ' %s="%s"' % (attr.nodeName, attr.nodeValue)
        print "<%s>" % tag_data

