from xml.xpath import ParsedExpr
from xml.xpath import Boolean
from xml.xpath.ParsedExpr import NodeSet

import DomTree

class DummyBooleanExpr(ParsedExpr.ParsedExpr):

    def __init__(self,val):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = Boolean.Boolean(val)

    def evaluate(self,context):
        return self.val

    def __repr__(self):
        return str(self.val)

class DummyNumberExpr(ParsedExpr.ParsedExpr):

    def __init__(self,val):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = val

    def evaluate(self,context):
        return self.val

    def __repr__(self):
        return str(self.val)

class DummyNodeSetExpr(ParsedExpr.ParsedExpr):
    def __init__(self,val=None):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = val or NodeSet([DomTree.ROOT, DomTree.GCHILD12])

    def evaluate(self,context):
        return self.val

    def select(self,context):
        return self.val

    def __repr__(self):
        return '<%d-item nodeset>' % len(self.val)

class DummyStringExpr(ParsedExpr.ParsedExpr):
    def __init__(self,val=None):
        ParsedExpr.ParsedExpr.__init__(self)
        self.val = val or 'DummyString'

    def evaluate(self,context):
        return self.val

    def __repr__(self):
        return repr(self.val)


boolT = DummyBooleanExpr(1)
boolF = DummyBooleanExpr(0)
    
num1 = DummyNumberExpr(1)
num3 = DummyNumberExpr(3)
numN4 = DummyNumberExpr(-4)
num4p5 = DummyNumberExpr(4.5)

nodeset0 = DummyNodeSetExpr([])
nodeset1 = DummyNodeSetExpr([DomTree.ROOT])
nodeset2 = DummyNodeSetExpr([DomTree.ROOT,DomTree.CHILD1])
nodeset3 = DummyNodeSetExpr([DomTree.CHILD1])
nodeset4 = DummyNodeSetExpr([DomTree.CHILD3])

strPi = DummyStringExpr('3.14')
strText = DummyStringExpr('Hi')
strPiText = DummyStringExpr('3.14Hi')
strSpace = DummyStringExpr('Ht    \t There\t   Mike')
