#!/usr/bin/env python
#
# File Name:        File Name
#
# Documentation:    http://docs.fourthought.com/file/name.html
#


def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()

    tester.startGroup('ParsedBooleanExpr')

    tester.startTest('Creating test environment')
    from xml.xpath import ParsedExpr
    from xml.xpath import XPath
    from Ft.Lib import boolean

    from DummyExpr import boolT, boolF
    from DummyExpr import num3, numN4, num4p5
    from DummyExpr import nodeset1, nodeset2, nodeset3
    from DummyExpr import strPi, strText
    
    tests = {ParsedExpr.ParsedRelationalExpr : [((XPath.LESS_THAN, strPi, numN4), boolean.false),
                                                ((XPath.LESS_THAN_EQUAL, strPi, numN4), boolean.false),
                                                ((XPath.GREATER_THAN, strPi, numN4), boolean.true),
                                                ((XPath.GREATER_THAN_EQUAL, strPi, strPi), boolean.true),
                                                ],
             ParsedExpr.ParsedEqualityExpr : [(('=', strPi, strPi), boolean.true),
                                              (('=', strPi, strText), boolean.false),
                                              ((XPath.NOT_EQUAL, strPi, numN4), boolean.true),
                                              ],
             ParsedExpr.ParsedAndExpr : [((boolT, boolT), boolean.true),
                                         ((boolT, boolF), boolean.false),
                                         ((boolF, boolF), boolean.false),
                                         ],
             ParsedExpr.ParsedOrExpr : [((boolT, boolF), boolean.true),
                                        ((boolT, boolT), boolean.true),
                                        ((boolF, boolF), boolean.false),
                                        ]
             }
    
    tester.testDone()

    for (expr, boolTests) in tests.items():
        for (args, expected) in boolTests:
            p = apply(expr, args)
            tester.startTest('Comparing %s' % repr(p))
            result = p.evaluate(None)
            tester.compare(result, expected)
            tester.testDone()

    tester.groupDone()

if __name__ == '__main__':
    test()
