#!/usr/bin/env python
#
# File Name:        File Name
#
# Documentation:    http://docs.fourthought.com/file/name.html
#


def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()

    tester.startGroup('ParsedNodeSetExpr')

    tester.startTest('Creating test environment')

    from xml.xpath import ParsedExpr
    from xml.xpath import XPath

    import DomTree
    from DummyExpr import boolT, boolF
    from DummyExpr import num3, numN4, num4p5
    from DummyExpr import nodeset1, nodeset2, nodeset3
    from DummyExpr import strPi, strText
    
    from xml.xpath import Context
    context1 = Context.Context(DomTree.CHILD1,1,2)
    context2 = Context.Context(DomTree.CHILD2,2,2)

    tests = {ParsedExpr.ParsedFilterExpr : [((nodeset2, boolT), context1, list(nodeset2.val)),
                                            ((nodeset2, boolF), context1, []),
                                            ],
             ParsedExpr.ParsedPathExpr : [(('/', nodeset2, nodeset1), context1, list(nodeset1.val)),
                                          ],
             ParsedExpr.ParsedUnionExpr : [((nodeset2, nodeset1), context1, list(nodeset2.val)),
                                           ],

             }

    tester.testDone()

    for (expr, boolTests) in tests.items():
        for (args, context, expected) in boolTests:
            p = apply(expr, args)
            tester.startTest('Comparing %s' % repr(p))
            result = p.evaluate(context)
            tester.compare(result, expected)
            tester.testDone()

    tester.groupDone()

if __name__ == '__main__':
    test()
