def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()

    tester.startGroup('AbbreviatedAbsoluteLocationPath')

    tester.startTest('Creating test environment')
    from xml.xpath import ParsedAbbreviatedAbsoluteLocationPath
    from xml.xpath import ParsedStep
    from xml.xpath import ParsedNodeTest
    from xml.xpath import ParsedPredicateList
    from xml.xpath import ParsedAxisSpecifier
    from xml.xpath import XPath
    from xml.xpath import Context
    import DomTree

    ppl = ParsedPredicateList.ParsedPredicateList([])
    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'*')
    as = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.CHILD)
    ps = ParsedStep.ParsedStep(as,nt,ppl)
    p = ParsedAbbreviatedAbsoluteLocationPath.ParsedAbbreviatedAbsoluteLocationPath(ps)
    tester.testDone()


    tester.startTest('Select of "%s"' % repr(p))
    con = Context.Context(DomTree.CHILD1,1,2)
    node_set = p.select(con)
    expected = [DomTree.ROOT, DomTree.CHILD1]
    expected.extend(DomTree.GCHILDREN1)
    expected.append(DomTree.CHILD2)
    expected.extend(DomTree.GCHILDREN2)
    expected.append(DomTree.CHILD3)
    tester.compare(expected, node_set)
    tester.testDone()

    return tester.groupDone()

if __name__ == '__main__':
    import sys

    import TestSuite
    tester = TestSuite.TestSuite()
    retVal = test(tester)
    sys.exit(retVal)
