import DomTree, DummyExpr

def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()

    tester.startGroup('ParsedAbbreviatedRelativeLocationPath')

    tester.startTest('Creating test environment')
    from xml.xpath import XPath
    from xml.xpath import ParsedAxisSpecifier
    from xml.xpath import ParsedNodeTest
    from xml.xpath import ParsedPredicateList
    from xml.xpath import ParsedStep
    from xml.xpath import ParsedAbbreviatedRelativeLocationPath
    from xml.xpath import Context

    as = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.CHILD)
    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'*')
    pl = ParsedPredicateList.ParsedPredicateList([])
    step = ParsedStep.ParsedStep(as,nt,pl)
    p = ParsedAbbreviatedRelativeLocationPath.ParsedAbbreviatedRelativeLocationPath(step, step)
    con = Context.Context(DomTree.ROOT,1,1)
    tester.testDone()

    tester.startTest('Checking select of "%s"' % repr(p))
    expected = DomTree.GCHILDREN1 + DomTree.GCHILDREN2
    node_set = p.select(con)
    tester.compare(expected, node_set)
    tester.testDone()

    return tester.groupDone()
    
if __name__ == '__main__':
    import sys

    import TestSuite
    tester = TestSuite.TestSuite()
    retVal = test(tester)
    sys.exit(retVal)
