import DomTree, DummyExpr

def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()

    tester.startGroup('ParsedAbsoluteLocationPath')

    tester.startTest('Creating test environment')
    from xml.xpath import ParsedAbsoluteLocationPath
    from xml.xpath import ParsedRelativeLocationPath
    from xml.xpath import ParsedStep
    from xml.xpath import ParsedNodeTest
    from xml.xpath import ParsedPredicateList
    from xml.xpath import XPath
    from xml.xpath import Context
    from xml.xpath import ParsedAbbreviatedAbsoluteLocationPath
    from xml.xpath import ParsedAxisSpecifier

    ppl = ParsedPredicateList.ParsedPredicateList([])
    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'*')
    as = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.CHILD)
    step = ParsedStep.ParsedStep(as,nt,ppl)
    
    tests = [(None, [DomTree.DOM]),
             (step, [DomTree.ROOT]),
             ]
    context = Context.Context(DomTree.CHILD1,1,2)
    tester.testDone()
             

    tester.startTest('Testing location paths')
    for arg,expected in tests:
        p = ParsedAbsoluteLocationPath.ParsedAbsoluteLocationPath(arg)
        result = p.select(context)
        tester.compare(expected, result, 'Select of "%s"' % repr(p))
    tester.testDone()

    return tester.groupDone()
    
if __name__ == '__main__':
    import sys

    import TestSuite
    tester = TestSuite.TestSuite()
    retVal = test(tester)
    sys.exit(retVal)
