#!/usr/bin/env python
#
# File Name:        File Name
#
# Author:           Mike Olson
#
# Creation Date:    1999-08-06
#
# Documentation:    http://docs.fourthought.com/file/name.html
#

def test():

    from xml.xpath import ParsedAxisSpecifier
    from xml.xpath import XPath
    from xml.xpath import Context
    import DomTree
    import sys

    rootContext = Context.Context(DomTree.ROOT,1,1)
    child1Context = Context.Context(DomTree.CHILD1,1,1)
    child2Context = Context.Context(DomTree.CHILD2,1,1)
    child3Context = Context.Context(DomTree.CHILD3,1,1)
    textContext = Context.Context(DomTree.TEXT1,1,1)
    gchild11Context = Context.Context(DomTree.GCHILD11,1,1)

    print "From Ancestor"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.ANCESTOR)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Ancestor or Self"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.ANCESTOR_OR_SELF)
    p.dump(sys.stdout)
    print
    rt = p.select(gchild11Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Attribute"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.ATTRIBUTE)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Child"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.CHILD)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Descendant"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.DESCENDANT)
    p.dump(sys.stdout)
    print
    rt = p.select(rootContext)
    print rt
    DomTree.PrintList(rt[0])

    print "From Descendant or self"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.DESCENDANT_OR_SELF)
    p.dump(sys.stdout)
    print
    rt = p.select(rootContext)
    print rt
    DomTree.PrintList(rt[0])

    print "From Following"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.FOLLOWING)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Following Sibling"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.FOLLOWING_SIBLING)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Namespace"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.NAMESPACE)
    p.dump(sys.stdout)
    print
    rt = p.select(child3Context)
    print rt

    print "From Parent"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.PARENT)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Preceding Siglings"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.PRECEDING_SIBLING)
    p.dump(sys.stdout)
    print
    rt = p.select(child2Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Preceding"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.PRECEDING)
    p.dump(sys.stdout)
    print
    rt = p.select(child2Context)
    print rt
    DomTree.PrintList(rt[0])

    print "From Self"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.SELF)
    p.dump(sys.stdout)
    print
    rt = p.select(rootContext)
    print rt
    DomTree.PrintList(rt[0])

    print "Abbreviated nothing"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(None)
    p.dump(sys.stdout)
    print
    rt = p.select(rootContext)
    print rt
    DomTree.PrintList(rt[0])


    print "Abbreviated @"
    p = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.AT)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    print rt
    DomTree.PrintList(rt[0])


if __name__ == '__main__':
    test()
