#
# File Name:        File Name
#
# Author:           Mike Olson
#
# Creation Date:    1999-08-06
#
# Documentation:    http://docs.fourthought.com/file/name.html
#

def test():

    import DomTree, sys
    from xml.xpath import ParsedLocationPath
    from xml.xpath import ParsedRelativeLocationPath
    from xml.xpath import ParsedAbsoluteLocationPath
    from xml.xpath import ParsedStep
    from xml.xpath import ParsedNodeTest
    from xml.xpath import ParsedExpr
    from xml.xpath import ParsedPredicate
    from xml.xpath import ParsedPredicateList
    from xml.xpath import ParsedAxisSpecifier
    from xml.xpath import XPath
    from xml.xpath import Context

    rootContext = Context.Context(DomTree.ROOT,1,1)
    child1Context = Context.Context(DomTree.CHILD1,1,3)
    child2Context = Context.Context(DomTree.CHILD2,2,3)
    textContext = Context.Context(DomTree.TEXT1,3,3)
    gchild11Context = Context.Context(DomTree.GCHILD11,1,2)

    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'GCHILD')
    ppl = ParsedPredicateList.ParsedPredicateList([])
    as = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.DESCENDANT)
    ps = ParsedStep.ParsedStep(as,nt,ppl)

    pr = ParsedRelativeLocationPath.ParsedRelativeLocationPath('step',ps,None)
    pa = ParsedAbsoluteLocationPath.ParsedAbsoluteLocationPath('/',pr)

    p = ParsedLocationPath.ParsedLocationPath(pr)
    p.dump(sys.stdout)
    rt = p.select(rootContext)
    DomTree.PrintList(rt)

    p = ParsedLocationPath.ParsedLocationPath(pa)
    p.dump(sys.stdout)
    print
    rt = p.select(rootContext)
    DomTree.PrintList(rt)

    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'CHILD2')
    as = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.CHILD)
    ps = ParsedStep.ParsedStep(as,nt,ppl)
    pr = ParsedRelativeLocationPath.ParsedRelativeLocationPath('step',ps,None)
    p = ParsedLocationPath.ParsedLocationPath(pr)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    DomTree.PrintList(rt)

    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'CHILD1')
    as = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.CHILD)
    ps2 = ParsedStep.ParsedStep(as,nt,ppl)
    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'ROOT')
    ps1 = ParsedStep.ParsedStep(as,nt,ppl)
    pr = ParsedRelativeLocationPath.ParsedRelativeLocationPath('step',ps1,None)
    pr = ParsedRelativeLocationPath.ParsedRelativeLocationPath('/',pr,ps2)
    pa = ParsedAbsoluteLocationPath.ParsedAbsoluteLocationPath('/',pr)

    p = ParsedLocationPath.ParsedLocationPath(pa)
    p.dump(sys.stdout)
    print
    rt = p.select(child1Context)
    DomTree.PrintList(rt)

    al = ParsedExpr.ParsedArgumentList()
    left = ParsedExpr.ParsedFunctionCallExpr('position',al)
    right = ParsedExpr.ParsedNLiteralExpr('1')
    exp = ParsedExpr.ParsedComparisonExpr('=',left,right)
    pred = ParsedPredicate.ParsedPredicate(exp)
    ppl = ParsedPredicateList.ParsedPredicateList([pred])
    
    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'CHILD1')
    ps2 = ParsedStep.ParsedStep(as,nt,ppl)

    pr = ParsedRelativeLocationPath.ParsedRelativeLocationPath('step',ps1,None)
    pr = ParsedRelativeLocationPath.ParsedRelativeLocationPath('/',pr,ps2)
    pa = ParsedAbsoluteLocationPath.ParsedAbsoluteLocationPath('/',pr)

    p = ParsedLocationPath.ParsedLocationPath(pa)
    p.dump(sys.stdout)
    rt = p.select(child1Context)
    DomTree.PrintList(rt)


if __name__ == '__main__':
    test()
