#!/usr/bin/env python
#
# File Name:        File Name
#
# Author:           Mike Olson
#
# Creation Date:    1999-08-06
#
# Documentation:    http://docs.fourthought.com/file/name.html
#
#

def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()

    tester.startGroup('ParsedNodeTest')
    
    tester.startTest('Creating test environment')
    from xml.xpath import ParsedNodeTest
    from xml.xpath import XPath
    from xml.xpath import Context
    from xml.xpath.Boolean import Boolean
    from Ft.Lib.boolean import true, false
    import DomTree

    context = Context.Context(DomTree.ROOT,1,1,{},{'bar':'http://foo.com'})
    tests = [((XPath.WILDCARD_NAME, '*'), [(DomTree.ROOT, true)]),
             ((XPath.WILDCARD_NAME, 'bar:CHILD3'), [(DomTree.ROOT, false),
                                                    (DomTree.CHILD1, false),
                                                    (DomTree.CHILD3, true),
                                                    ]),
             ((XPath.WILDCARD_NAME, 'bar:*'), [(DomTree.ROOT, false),
                                               (DomTree.CHILD1, false),
                                               (DomTree.CHILD3, true),
                                               ]),
             ((XPath.NODE, ''), [(DomTree.ROOT, true),
                                 (DomTree.TEXT1, true),
                                 ]),
             ((XPath.TEXT, ''), [(DomTree.ROOT, false),
                                 (DomTree.TEXT1, true),
                                 ]),
             ((XPath.COMMENT, ''), [(DomTree.ROOT, false),
                                    (DomTree.COMMENT, true),
                                    ]),
             ((XPath.PROCESSING_INSTRUCTION,''), [(DomTree.ROOT, false),
                                                  (DomTree.PI, true),
                                                  ]),
             ((XPath.PROCESSING_INSTRUCTION,'xml-stylesheet'), [(DomTree.PI, true),
                                                                (DomTree.PI2, false),
                                                                ]),
             ]
                                                  
    tester.testDone()
    
    tester.startTest('Running node-tests')
    for args, nodeTests in tests:
        p = apply(ParsedNodeTest.ParsedNodeTest, args)
        for node,expected in nodeTests:
            # Use Booleans for display only
            result = Boolean(p.match(context, node))
            tester.compare(expected, result, 'Filter of "%s" against %s' % (
                repr(p),
                node.nodeName,
                ))
    tester.testDone()

    return tester.groupDone()

if __name__ == '__main__':
    import sys
    retval = test()
    sys.exit(retval)

