def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()

    tester.startGroup('ParsedPredicateList')
    
    tester.startTest('Checking syntax')
    from xml.xpath import ParsedPredicateList
    from xml.xpath import ParsedExpr
    from xml.xpath import Context
    from xml.xpath import Boolean
    import DomTree, DummyExpr
    tester.testDone()
    
    
    tester.startTest('Creating test environment')
    t = DummyExpr.DummyBooleanExpr(1)
    f = DummyExpr.DummyBooleanExpr(0)
    a = ParsedExpr.ParsedAndExpr(t,f)
    o = ParsedExpr.ParsedOrExpr(t,f)
    context = Context.Context(DomTree.ROOT,1,1)
    tester.testDone()
    
    p = ParsedPredicateList.ParsedPredicateList([a,t])
    tester.startTest('Filter of "%s"' % repr(p))
    result = p.filter([context.node], context, 0)
    if len(result):
        tester.error()
    tester.testDone()
    
    p = ParsedPredicateList.ParsedPredicateList([o,t])
    tester.startTest('Filter of "%s"' % repr(p))
    result = p.filter([context.node], context, 0)
    if not result or result[0] != DomTree.ROOT:
        tester.error()
    tester.testDone()

    return tester.groupDone()

if __name__ == '__main__':
    import sys
    
    retval = test()
    sys.exit(retval)
