def test(tester=None):
    if tester is None:
        import TestSuite
        tester = TestSuite.TestSuite()
       
    tester.startGroup('ParsedRelativeLocationPath')
    
    tester.startTest('Checking syntax')
    from xml.xpath import ParsedAbbreviatedRelativeLocationPath
    from xml.xpath import ParsedRelativeLocationPath
    from xml.xpath import ParsedStep
    from xml.xpath import ParsedNodeTest
    from xml.xpath import ParsedAxisSpecifier
    from xml.xpath import ParsedPredicateList
    from xml.xpath import XPath
    from xml.xpath import Context
    import DomTree, DummyExpr
    tester.testDone()
    
    tester.startTest('Creating test environment')
    ppl = ParsedPredicateList.ParsedPredicateList([])
    nt = ParsedNodeTest.ParsedNodeTest(XPath.WILDCARD_NAME,'*')
    as = ParsedAxisSpecifier.ParsedAxisSpecifier(XPath.CHILD)
    ps = ParsedStep.ParsedStep(as,nt,ppl)
    context = Context.Context(DomTree.ROOT,1,1)
    tester.testDone()

    p = ParsedRelativeLocationPath.ParsedRelativeLocationPath(ps,ps)
    tester.startTest('Select of "%s"' % repr(p))
    expected = DomTree.GCHILDREN1 + DomTree.GCHILDREN2
    node_set = p.select(context)
    if len(node_set) != len(expected):
        tester.error('Wrong size of node set. Expected %d, got %d' % (
            len(expected),
            len(node_set)
            ))
    results = map(lambda a,b: a == b, node_set, expected)
    if not reduce(lambda a,b: a and b, results, 1):
        tester.error('Invalid node in node set. Expected %s\ngot\n%s' % (
            str(node_set),
            str(expected),
            ))
    tester.testDone()
    


if __name__ == '__main__':
    import sys
    
    retval = test()
    sys.exit(retval)
