#4XPath Performance test from "Olivier Deckmyn" <odeckmyn.list@teaser.fr>, with import and filename updates
"""
Subject: [4suite] 4XPath performance ?
Date: Thu, 8 Jun 2000 16:30:21 +0200
From: "Olivier Deckmyn" <odeckmyn.list@teaser.fr>
To: "4Suite list" <4suite@dollar.fourthought.com>

I am playing and testing 4XPath....
And I am a little afraid of the results I see...
The machine is a Dell Server (2400) with a single PIII-750 and 256MB RAM,
USCSI disks (10K RPM), running FreeBSD4.

There is a lot of memory, cpu is not used for anything else than the test...

With a 100KB xml file, I have applied the attached test1.py

Here are the results :
QUERY="//author" (no match in the file)
Reading document
took 1.336457 sec
Starting query
took 307.572385 sec
Indexing DOM
took 0.125362 sec
Starting query
took 84.692544 sec

QUERY="//date" (few matches in the file)
Reading document
took 1.341848 sec
Starting query
took 308.466919 sec
<date> 10 October 1996</date><date>1 August 1996</date><date>17 April
1996</date><date> 17 April 1996</date><date> 17 April 1996</date><date> 12
April 1996</date><date>27 March 1996</date><date>27 March
1996</date><date>23 February 1996</date><date>9 December 1996</date><date>
29 November 1996</date><date> 31 October 1996</date>Indexing DOM
took 0.128668 sec
Starting query
took 85.145023 sec
<date> 10 October 1996</date><date>1 August 1996</date><date>17 April
1996</date><date> 17 April 1996</date><date> 17 April 1996</date><date> 12
April 1996</date><date>27 March 1996</date><date>27 March
1996</date><date>23 February 1996</date><date>9 December 1996</date><date>
29 November 1996</date><date> 31 October 1996</date>


Result :
Indexing is worth the price ! Very quick index build, and 3.5x speed gain
...
But, it very slow anyway :(

Is this the "normal" performance ? Can I do better?
"""


from xml.dom import ext
from xml.dom import Document
from xml.dom.ext.reader import Sax
from xml.xpath import Evaluate
from xml.xpath import Util
import os
import time

t0=0

def chrono_start(msg="Starting"):
    global t0
    print msg
    t0=time.time()

def chrono_stop():
    global t0
    print "took %f sec" % (time.time()-t0)
    t0=0
 

def dom_from_file(fileName):
    try:
        chrono_start("Reading document")
        result=Sax.FromXmlFile(fileName, validate=0)
    except Sax.saxlib.SAXException, msg:
        print "SAXException caught:", msg
    except Sax.saxlib.SAXParseException, msg:
        print "SAXParseException caught:", msg
    chrono_stop()
    return result
    

def test_query(dom_object, query):
    chrono_start("Starting query")
    result = Evaluate(query, dom_object.documentElement)
    chrono_stop()
    result
    return result

def test1(fileName, queryString):
    xml_dom_object=dom_from_file(fileName)

    test_query(xml_dom_object, queryString)
    
    chrono_start("Indexing DOM")
    Util.IndexDocument(xml_dom_object)
    chrono_stop()

    test_query(xml_dom_object, queryString)

    ext.ReleaseNode(xml_dom_object)

if __name__=='__main__':
    test1("od_20000608.xml","//author") #no match
    test1("od_20000608.xml","//date") #some short matches

