import re
from xml.xslt import AttributeValueTemplate

expected_1 = ""

def Test(tester):
    test_strings = ['Senatus{{populisque}}romae',
                    'Senatus{{{"populisque}}"}romae',
                    ''
        ]

    expected = [(['Senatus{populisque}romae'], []),
                (['Senatus{', 'romae'], ['"populisque}"']),
                ([''], [])
        ]

    combine = map(lambda a,b: (a,b), test_strings, expected)

    tester.startGroup("Attribute Value Templates")
    
    for i,o in combine:
        avt = AttributeValueTemplate.AttributeValueTemplate(i)
        tester.startTest(str(avt))
        pp = avt.__dict__['_plainParts']
        tester.testResults(o[0],pp,done=0)
        tp = avt.__dict__['_parsedParts']
        if len(tp):
            # Needed because of expression parsing
            tp = ['"'+tp[0].evaluate(None)+'"']
        tester.testResults(o[1],tp,done=0)
        tester.testDone()

    tester.groupDone()
    return 1

if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1, 1)
    Test(tester)

