import os,sys, test_harness

sheet_1 = """<?xml version="1.0"?>
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:ft="http://namespaces.4suite.org/xpath/extensions"
  extension-element-prefixes="ft"
  version="1.0"
  >

  <xsl:output method="text"/>
  
  <xsl:template match="/">
    <xsl:variable name='matches' select="ft:search-re('([a-z])([0-9])', 'a1b2c3d')"/>
    <xsl:apply-templates select='$matches'/>
  </xsl:template>

  <xsl:template match="Match">
    <xsl:text>Match 1 groups: </xsl:text><xsl:apply-templates/><xsl:text>&#10;</xsl:text>
  </xsl:template>
  
  <xsl:template match="Group">
    <xsl:text>"</xsl:text><xsl:apply-templates/><xsl:text>" </xsl:text>
  </xsl:template>
  
</xsl:stylesheet>
"""

##preg_match_all("Call 555-1212 or 1-800-555-1212 or (612) 555-1313",
##"/\(? (\d{3})? \)? (?(1) [\-\s] ) \d{3}-\d{4}/x")

##would return a nodeset whose structure could be:

##<matches>  <!-- maybe we don't need a document element here ? -->
## <match>
##  <part>555-1212</part>
## </match>
## <match>
##  <part>1-800-555-1212</part>
## </match>
## <match>
##  <part>(612) 555-1313</part>
## </match>
##</matches>

sheet_2 = """<?xml version="1.0"?>
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:ft="http://namespaces.4suite.org/xpath/extensions"
  extension-element-prefixes="ft"
  version="1.0"
  >

  <xsl:output method="text"/>
  
  <xsl:template match="/">
    <xsl:variable name='matches' select="ft:search-re('Call 555-1212 or 1-800-555-1212 or (612) 555-1313', '/\(? (\d{3})? \)? (?(1) [\-\s] ) \d{3}-\d{4}/x')"/>
    <xsl:apply-templates select='$matches'/>
  </xsl:template>

  <xsl:template match="Match">
    <xsl:text>Match 1 groups: </xsl:text><xsl:apply-templates/><xsl:text>&#10;</xsl:text>
  </xsl:template>
  
  <xsl:template match="Group">
    <xsl:text>"</xsl:text><xsl:apply-templates/><xsl:text>" </xsl:text>
  </xsl:template>
  
</xsl:stylesheet>
"""

source_1 = """<dummy/>"""

expected_1 = """\
Match 1 groups: "a" "1" 
Match 1 groups: "b" "2" 
Match 1 groups: "c" "3" 
"""

expected_2 = """\
Match 1 groups: "a" "1" 
Match 1 groups: "b" "2" 
Match 1 groups: "c" "3" 
"""

def Test(tester):
    tester.startGroup("ft:search-re, case 1")

    source = test_harness.FileInfo(string=source_1)
    sty = test_harness.FileInfo(string=sheet_1)
    #tester.startTest("Test ft:search-re") 
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    expected_1,
                                    compareFunc=cmp
                                    )

    res = xtest.test(tester)
    tester.groupDone()

##    tester.startGroup("ft:search-re, case 2 ('Eric van der Vlist's example')")

##    source = test_harness.FileInfo(string=source_1)
##    sty = test_harness.FileInfo(string=sheet_2)
##    xtest = test_harness.XsltTester(source,
##                                    [sty],
##                                    expected_2,
##                                    compareFunc=cmp
##                                    )

##    res = xtest.test(tester)
##    tester.groupDone()

    return res


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    Test(tester)

