import os,sys, test_harness

sheet_1 = """<?xml version="1.0"?>
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:ft="http://namespaces.4suite.org/xpath/extensions"
  extension-element-prefixes="ft"
  version="1.0"
  >

  <xsl:output method="text"/>
  <xsl:param name='name'/>

  <xsl:template match="/">
    <xsl:text>
    Printed before the ft:write-file
    </xsl:text>
    <ft:write-file name='{$name}' overwrite='yes'>
      <ft:output method="text"/>
      <xsl:text>
      Here is sample output
      From ft:write-file
      </xsl:text>
    </ft:write-file>
    <xsl:text>
    Printed after the ft:write-file
    </xsl:text>
  </xsl:template>

</xsl:stylesheet>
"""

source_1 = """<dummy/>"""

expected_1 = """
    Printed before the ft:write-file
    
    Printed after the ft:write-file
    """

file_expected_1 = """
      Here is sample output
      From ft:write-file
      """

if sys.platform[:3] != 'win':
    fileName = '/tmp/ft-output1.txt'
else:
    fileName = os.path.join(os.environ['TEMP'], 'ft-output1.txt')


def Test(tester):


    tester.startGroup("ft_write_file")

    if os.path.exists(fileName):
        os.unlink(fileName)

    source = test_harness.FileInfo(string=source_1)
    sty = test_harness.FileInfo(string=sheet_1)
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    expected_1,
                                    topLevelParams={('','name'):fileName},
                                    compareFunc = cmp
                                    )

    res = xtest.test(tester)
    tester.startTest("Test File results") 
    tester.testResults(1,os.path.exists(fileName),done=0)
    fileData = open(fileName,'r').read()
    tester.testResults(file_expected_1,fileData,done=0)
    tester.testDone()
    tester.groupDone()
    if os.path.exists(fileName):
        os.unlink(fileName)
    return res


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    Test(tester)

