import test_harness, cStringIO, sys

sheet_str = """<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
version="1.0">

  <xsl:template match="/">
    <HTML>
    <HEAD><TITLE>Address Book</TITLE>
    </HEAD>
    <BODY>
    <TABLE><xsl:apply-templates/></TABLE>
    </BODY>
    </HTML>
  </xsl:template>

  <xsl:template match="ENTRY">
        <xsl:element name='TR'>
        <xsl:apply-templates select='NAME'/>
        </xsl:element>
  </xsl:template>

  <xsl:template match="NAME">
    <xsl:element name='TD'>
    <xsl:attribute name='ALIGN'>CENTER</xsl:attribute>
      <xsl:message>We're in the thick of processing NAME elements</xsl:message>
      <B><xsl:apply-templates/></B>
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
"""

expected = """<HTML>
  <HEAD>
    <META HTTP-EQUIV='Content-Type' CONTENT='text/html; charset=UTF-8'>
    <TITLE>Address Book</TITLE>
  </HEAD>
  <BODY>
    <TABLE>
      <TR>
        <TD ALIGN='CENTER'>
          <B>Pieter Aaron</B>
        </TD>
      </TR>
      <TR>
        <TD ALIGN='CENTER'>
          <B>Emeka Ndubuisi</B>
        </TD>
      </TR>
      <TR>
        <TD ALIGN='CENTER'>
          <B>Vasia Zhugenev</B>
        </TD>
      </TR>
    </TABLE>
  </BODY>
</HTML>"""

msg_results="""STYLESHEET MESSAGE:
We're in the thick of processing NAME elements
END STYLESHEET MESSAGE:
"""

def Test(tester):


    tester.startGroup("Message")

    source = test_harness.FileInfo(uri="addr_book1.xml",nsAware=0)
    sty = test_harness.FileInfo(string=sheet_str)
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    expected,
                                    )

    st = cStringIO.StringIO()
    origErr = sys.stderr
    sys.stderr = st
    try:
        res = xtest.test(tester)
    except Exception, e:
        print st.getvalue()
        raise e

    sys.stderr = origErr

    tester.startTest("Message Output")
    tester.testResults(msg_results*(xtest.quick and 3 or 51),st.getvalue(),done=0)
    tester.testDone()

    tester.groupDone()
    return res
    
    processor.appendStylesheetString(sheet_str)
    result = processor.runUri('addr_book1.xml', ignorePis=1)
    if result != expected:
        raise Exception('Failed.  Expected\n"""%s"""\ngot\n"""%s"""'%(expected, result))
    print '*** Result ***'
    print result


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    Test(tester)

