# XPatternParser Test patterns
from xml.xslt import XPatternParser

class TestCase:
    def __init__(self, pattern, context=None, expected=None):
        self.pattern = pattern
        self.context = context
        self.expected = expected



patterns = [TestCase('para'),
            TestCase('*'),
            TestCase('chapter | appendix'),
            TestCase('olist/item'),
            TestCase('appendix//para'),
            TestCase('/'),
            TestCase('text()'),
            TestCase('processing-instruction()'),
            TestCase('node()'),
            TestCase('id("W11")'),
            TestCase('para[1]'),
            TestCase('*[position()=1 and self::para]',expected='*[position() = 1 and self::para]'),
            TestCase('para[last()=1]',expected='para[last() = 1]'),
            TestCase('items/item[position()>1]',expected='items/item[position() > 1.0]'),
            TestCase('item[(position() mod 2) = 1]', expected='item[position() mod 2 = 1]'),
            TestCase('div[@class="appendix"]//p',expected='div[attribute::class = "appendix"]//p'),
            TestCase('@class'),
            TestCase('@*'),
            TestCase('appendix//ulist/item[position()=1]',expected='appendix//ulist/item[position() = 1]'),
            TestCase('* | /'),
            TestCase('text() | @*'),
            ]

def Test(tester):
    parser = XPatternParser.XPatternParser()
    tester.startGroup("Patterns")
    for case in patterns:
        tester.startTest(case.pattern)
        #print '-'*60
        #print "Parsing '%s' [#%d]" % (case.pattern, count)
        try:
            result = parser.parsePattern(case.pattern)
            tester.compare(case.expected and case.expected or case.pattern, repr(result))
        except:
            result.pprint()
            raise
        tester.testDone()

    tester.groupDone()
    return 1

if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    Test(tester)
