import test_harness

sheet_str = """<?xml version="1.0"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:template match="/">
    <xsl:value-of select="system-property('xsl:vendor-url')"/>
  </xsl:template> 

</xsl:transform>"""

xml_source = """<dummy/>"""


expected = """<?xml version='1.0' encoding='UTF-8'?>
http://4Suite.org"""


def Test(tester):

    tester.startGroup("XSLT Functions")

    source = test_harness.FileInfo(string=xml_source)
    sty = test_harness.FileInfo(string=sheet_str)
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    expected,
                                    compareFunc=cmp,
                                    )

    res = xtest.test(tester)
    tester.groupDone()
    return res

if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1, 1)
    Test(tester)

