import os, cStringIO
from Ft.DbDom import Dom
from Ft.Ods import Database
from Ft.DbDom import Reader
from xml.dom.ext import PrettyPrint,StripXml,Print
from Ft.Ods import FreePersistentObject
from Ft.Lib import TreeCompare


from xml.xpath import Evaluate

AL_NS = ''

DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

def test1(tester,data):

    db = Database.Database()
    db.open(DBNAME)
    tx = db.new()
    tx.begin()

    tester.startGroup("Create and Clone")

    tester.startTest("Read Doc")
    r = Reader.DbDomReader()
    doc = r.fromString(data)
    tester.testDone()

    tester.startTest("Cloning")
    doc2 = doc.cloneNode(1)
    e2 = doc.documentElement.cloneNode(0)

    tester.testDone()
    tester.startTest("Compare")

    st = cStringIO.StringIO()
    Print(doc,stream=st)
    xml1 = st.getvalue()
    st = cStringIO.StringIO()
    Print(doc2,stream=st)
    xml2 = st.getvalue()

    tester.testResults(xml1,xml2,done=0,func=TreeCompare.TreeCompare)
    tester.testResults(0,len(e2.childNodes),done=0)
    tester.testDone()
    tester.groupDone()
    tx.commit()
    db.close()


def test2(tester):
    tester.startGroup("Test 2")
    db = Database.Database() 
    db.open(DBNAME) 
    tx = db.new() 
    tx.begin() 

    tester.startTest("Clone Attr")

    d = Dom.DocumentImp() 
    e = d.createElementNS('','root') 
    d.appendChild(e) 
    e.setAttributeNS('','foo','bar') 
    f=d.createElementNS('','child') 
    e.appendChild(f) 

    for attr in e.attributes: 
        n = attr.cloneNode(1)
        print n
        f.setAttributeNodeNS(n) 

    tester.testDone()
    tx.commit() 
    tester.groupDone()

def test(tester):
    data = open('addr_book1.xml').read()
    test1(tester,data)
    test2(tester)


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
