import os
from Ft.DbDom import Dom
from Ft.Ods import Database
from Ft.DbDom import Reader
from xml.dom.ext import PrettyPrint,StripXml,Print
from Ft.Ods import FreePersistentObject

from xml.xpath import Evaluate

AL_NS = ''

DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

class MemoryDocument(Dom.DocumentImp) :
    def __init__(self) :
        Dom.DocumentImp.__init__(self)
        self.eid_count = 1
        self.eid_ref_count = {}
        
    def add_element(self,element) :
        """if the element has not already an eid (== not yet in memory)
        assign unique id to the element and append it to memory.
        """
        global tx
        eid = element.getAttributeNS(AL_NS,'eid')
        if not eid :
            eid = str(self.eid_count)
            element.setAttributeNS(AL_NS,'eid',eid)
            self.eid_count = self.eid_count + 1
            self.eid_ref_count[eid] = 1

            self.documentElement.appendChild(element)

            ### Uncomment following line to see the bug
            tx.checkpoint()

            for node in self.documentElement.childNodes[:] :
                if node.tagName == 'plan' :
                    node.element_change(element)

        return eid, element



mydoc='''<root><child id="1"><info/></child>
<child id="2"><info>foo</info></child></root>'''

def test(tester):

    db = Database.Database()
    db.open(DBNAME)
    global tx
    tx = db.new()
    tx.begin()
    
    doc = MemoryDocument()
    e = doc.createElementNS('','elt')
    doc.appendChild(e)
    tx.checkpoint()
    r = Reader.DbDomReader()
    
    frag = r.fromString(mydoc,doc)
    
    map(doc.add_element, Evaluate('root/child',frag))
    
    tx.commit()
    
    PrettyPrint(doc)

    db.close()

if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)

