#Test basic persistent and access of DOM objects

from Ft.DbDom import Reader
from Ft.Ods import Database

import sys, os
DBNAME=os.environ.get("ODS_TEST_DB","ods:test")

def test(tester):
    from xml.xslt import Processor

    import time
    db = Database.Database()
    db.open(DBNAME)
    tx = db.new()
    tx.begin()   

    r = Reader.DbDomReader()
    doc = r.fromUri('addr_book1.xml')

    if db.lookup('document'):
        db.unbind('document')

    db.bind(doc,'document')

    processor = Processor.Processor()
    processor.appendStylesheetFile("addr_book1.xsl")

    start = time.time()
    result = processor.runNode(doc)
    end = time.time()

    tx.commit()

    print "From Cached DB %f" % (end - start)

    print result

    tx = db.new()
    tx.begin()   

    doc = db.lookup('document')

    processor = Processor.Processor()
    processor.appendStylesheetFile("addr_book1.xsl")

    start = time.time()
    result = processor.runNode(doc)
    end = time.time()

    tx.commit()

    print "From Virgin DB %f" % (end - start)

    print result

    processor = Processor.Processor()
    processor.appendStylesheetFile("addr_book1.xsl")

    start = time.time()

    result = processor.runUri("addr_book1.xml")
    end = time.time()

    print "From File %f" % (end - start)
    print result

    processor = Processor.Processor()
    processor.appendStylesheetFile("addr_book1.xsl")
    from Ft.Lib import cDomlette
    r = cDomlette.RawExpatReader()
    doc = r.fromUri('addr_book1.xml')
    start = time.time()

    result = processor.runNode(doc)
    end = time.time()

    print "From cDomlette Node %f" % (end - start)
    print result
    db.close()

if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
