


from Ft.Lib import DbmDatabase



def test_create(tester):

    tester.startGroup("Database Creation")
    dbName='test'

    tester.startTest("Create")
    newDb = DbmDatabase.CreateDatabase('test1')

    res = DbmDatabase.GetAllDatabaseNames()
    tester.testResults(2,len(res),done=0)
    tester.testResults(1,res.count('template1'),done=0)
    tester.testResults(1,res.count('test1'),done=0)
    tester.testDone()

    tester.groupDone()


def test_drop(tester):

    tester.startGroup("Drop Database")

    tester.startTest("Drop")
    newDb = DbmDatabase.DropDatabase('test1')

    res = DbmDatabase.GetAllDatabaseNames()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('template1'),done=0)
    tester.testDone()


    tester.groupDone()

def test_table_create(tester):

    tester.startGroup("Create Table")

    tester.startTest("Create DB")
    DbmDatabase.CreateDatabase('test1')
    tester.testDone()
    
    tester.startTest("Create and Rollback")
    db = DbmDatabase.Database('test1')
    t = db.createTable('table1')
    res = db.getAllTableNames()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('table1'),done=0)
    db.rollback()
    db = DbmDatabase.Database('test1')
    res = db.getAllTableNames()
    tester.testResults(0,len(res),done=0)
    db.rollback()
    tester.testDone()

    tester.startTest("Create and Commit")
    db = DbmDatabase.Database('test1')
    t = db.createTable('table1')
    res = db.getAllTableNames()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('table1'),done=0)
    db.commit()
    db = DbmDatabase.Database('test1')
    res = db.getAllTableNames()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('table1'),done=0)
    db.rollback()
    tester.testDone()
    tester.groupDone()

def test_get_table(tester):

    tester.startGroup("Get Table")

    tester.startTest("getTable")

    db = DbmDatabase.Database('test1')

    t = db.getTable('table1')

    tester.testDone()

    tester.startTest("pythonic interface")
    t = db['table1']
    res = db.keys()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('table1'),done=0)
    db.rollback()
    tester.testDone()
    tester.groupDone()


def test_table_insert(tester):

    tester.startGroup("Table Insert")

    tester.startTest("Insert in new table, rollback")

    db = DbmDatabase.Database('test1')
    t = db.createTable('table2')
    db.commit()

    db = DbmDatabase.Database('test1')
    t = db['table2']
    t['key1'] = "Foo"

    tester.testResults("Foo",t['key1'],done=0)
    res = t.keys()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('key1'),done=0)
    tester.testResults(1,t.has_key('key1'),done=0)
    tester.testResults("Foo",t.get('key1'),done=0)
    tester.testResults(None,t.get('key2'),done=0)
    tester.testResults(1,len(t),done=0)
    db.rollback()

    db = DbmDatabase.Database('test1')
    db = DbmDatabase.Database('test1')
    t = db['table2']
    res = t.keys()
    tester.testResults(0,len(res),done=0)
    tester.testResults(0,t.has_key('key1'),done=0)
    tester.testResults(None,t.get('key1'),done=0)
    tester.testResults(0,len(t),done=0)
    db.rollback()


    tester.testDone()

    tester.startTest("Insert in new table, commit")

    db = DbmDatabase.Database('test1')
    t = db['table2']
    t['key1'] = "Foo"

    tester.testResults("Foo",t['key1'],done=0)
    res = t.keys()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('key1'),done=0)
    tester.testResults(1,t.has_key('key1'),done=0)
    tester.testResults("Foo",t.get('key1'),done=0)
    tester.testResults(None,t.get('key2'),done=0)
    tester.testResults(1,len(t),done=0)
    db.commit()

    db = DbmDatabase.Database('test1')
    t = db['table2']
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('key1'),done=0)
    tester.testResults(1,t.has_key('key1'),done=0)
    tester.testResults("Foo",t.get('key1'),done=0)
    tester.testResults(None,t.get('key2'),done=0)
    tester.testResults(1,len(t),done=0)
    db.rollback()


    tester.testDone()

    tester.groupDone()

def test_table_delete(tester):

    tester.startGroup("Table Delete")

    tester.startTest("Delete from table, rollback")

    db = DbmDatabase.Database('test1')
    t = db.createTable('table3')
    t['key1'] = "Foo"
    db.commit()

    db = DbmDatabase.Database('test1')
    t = db['table3']
    del t['key1']

    res = t.keys()
    tester.testResults(0,len(res),done=0)
    tester.testResults(0,t.has_key('key1'),done=0)
    tester.testResults(None,t.get('key1'),done=0)
    tester.testResults(0,len(t),done=0)
    db.rollback()


    db = DbmDatabase.Database('test1')
    t = db['table3']
    tester.testResults("Foo",t['key1'],done=0)
    res = t.keys()
    tester.testResults(1,len(res),done=0)
    tester.testResults(1,res.count('key1'),done=0)
    tester.testResults(1,t.has_key('key1'),done=0)
    tester.testResults("Foo",t.get('key1'),done=0)
    tester.testResults(None,t.get('key2'),done=0)
    tester.testResults(1,len(t),done=0)
    db.commit()



    tester.testDone()

    tester.startTest("Delete from table, commit")

    db = DbmDatabase.Database('test1')
    t = db['table3']
    del t['key1']

    res = t.keys()
    tester.testResults(0,len(res),done=0)
    tester.testResults(0,t.has_key('key1'),done=0)
    tester.testResults(None,t.get('key1'),done=0)
    tester.testResults(0,len(t),done=0)
    db.commit()

    db = DbmDatabase.Database('test1')
    t = db['table3']
    tester.testResults(0,len(res),done=0)
    tester.testResults(0,t.has_key('key1'),done=0)
    tester.testResults(None,t.get('key1'),done=0)
    tester.testResults(0,len(t),done=0)
    db.commit()
    tester.testDone()

    tester.groupDone()



def test(tester):
    import os
    for name in DbmDatabase.GetAllDatabaseNames():
        if name in ['template1']:
            continue
        os.system('rm -rf %s' % os.path.join(DbmDatabase.DATABASE_DIR,name))

    test_create(tester)
    test_drop(tester)
    test_table_create(tester)
    test_get_table(tester)
    test_table_insert(tester)
    test_table_delete(tester)


if __name__ == '__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    test(tester)
